﻿''' <summary>
''' Gestiona la comunicació entre l'aplicació i la BBDD en l'àmbit de ajuda
''' </summary>
''' <remarks></remarks>
Public Class GestorAjudaBD
    Dim dc As CampusNetDataContext = New CampusNetDataContext()

    'INSERT

    ''' <summary>
    ''' Crea una nova FAQ
    ''' </summary>
    ''' <param name="pregunta"></param>
    ''' <param name="respuesta"></param>
    ''' <returns>0 si correcte ,1 altrament</returns>
    ''' <remarks></remarks>
    Function NovaFAQ(ByVal pregunta As String, ByVal respuesta As String) As Integer
        Dim resultat As Integer

        Try
            dc.NovaFAQ(pregunta, respuesta)
            resultat = 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorAjudaBD_NovaFAQ & ex.Message, vbExclamation)
            resultat = 1
        End Try
        Return resultat



    End Function

    'UPDATE

    ''' <summary>
    ''' ACtualitza les dades d'una FAQ
    ''' </summary>
    ''' <param name="id"></param>
    ''' <param name="pregunta"></param>
    ''' <param name="respuesta"></param>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    Function ModificaFAQ(ByVal id As String, ByVal pregunta As String, ByVal respuesta As String)
        Dim resultat As Integer
        Try
            dc.ModificaFAQ(id, pregunta, respuesta)
            resultat = 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorAjudaBD_ModificaFAQ & ex.Message)
            resultat = 1
        End Try
        Return resultat
    End Function

    'SELECT

    ''' <summary>
    ''' Retorna la FAQ amb id=id
    ''' </summary>
    ''' <param name="id"></param>
    ''' <returns>la FAQ</returns>
    ''' <remarks></remarks>
    Function RetornaFAQ(ByVal id As Integer) As System.Data.Linq.ISingleResult(Of RetornaLlistaFAQ_IdResult)
        Try
            Return dc.RetornaLlistaFAQ_Id(id)

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorAjudaBD_RetornaFAQ & ex.Message, vbExclamation)
            Return Nothing
        End Try
    End Function

    ''' <summary>
    '''  Retorna la llista de totes les FAQ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function RetornaLlistaFAQ() As System.Data.Linq.ISingleResult(Of RetornaLlistaFAQResult)
        Try
            Return dc.RetornaLlistaFAQ()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorAjudaBD_RetornaFAQ & ex.Message, vbExclamation)
            Return Nothing
        End Try

    End Function



    'DELETE

    ''' <summary>
    ''' Elimina la FAQ amb Id=id
    ''' </summary>
    ''' <param name="id"></param>
    ''' <remarks></remarks>
    Sub EliminaFAQ(ByVal id As String)
        Try
            dc.EliminaFAQ(id)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorAjudaBD_EliminaFAQ & ex.Message, vbExclamation)
        End Try
    End Sub
End Class
