﻿

''' <summary>
''' Gestiona la comunicació entre l'aplicació i la BBDD en l'àmbit de NOTÍCIES
''' </summary>
''' <remarks></remarks>
Public Class GestorNoticiesBD
    Dim dc As CampusNetDataContext = New CampusNetDataContext()

    'INSERT

    ''' <summary>
    ''' Crea una nova noticia
    ''' </summary>
    ''' <param name="contingut">contingut</param>
    ''' <param name="enllac">enllac</param>
    ''' <param name="perfil">perfil</param>
    ''' <param name="data">data</param>
    ''' <returns>0 si correcte ,1 altrament</returns>
    ''' <remarks></remarks>
    Function NovaNoticia(ByVal contingut As String, ByVal enllac As String, ByVal perfil As String, ByVal data As Date) As Integer
        Dim resultat As Integer

        Try
            dc.NovaNoticia(contingut, enllac, perfil, data)
            resultat = 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorNoticiesBD_NovaNoticia & ex.Message, vbExclamation)
            resultat = 1
        End Try
        Return resultat



    End Function

    'UPDATE
    ''' <summary>
    ''' ACtualitza les dades d'una noticia
    ''' </summary>
    ''' <param name="id"></param>
    ''' <param name="contingut"></param>
    ''' <param name="enllac"></param>
    ''' <param name="data"></param>
    ''' <param name="perfil"></param>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    Function ModificaNoticia(ByVal id As String, ByVal contingut As String, ByVal enllac As String, ByVal data As Date, ByVal perfil As String)
        Dim resultat As Integer
        Try
            dc.ModificaNoticia(id, contingut, enllac, data, perfil)
            resultat = 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorNoticiesBD_ModificaNoticia & ex.Message)
            resultat = 1
        End Try
        Return resultat
    End Function
    'SELECT

    ''' <summary>
    ''' Retorna la noticia amb id=id
    ''' </summary>
    ''' <param name="id"></param>
    ''' <returns>la noticia</returns>
    ''' <remarks></remarks>
    Function RetornaNoticia(ByVal id As Integer) As System.Data.Linq.ISingleResult(Of RetornaNoticiaResult)
        Try
            Return dc.RetornaNoticia(id)

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorNoticiesBD_RetornaNoticia & ex.Message, vbExclamation)
            Return Nothing
        End Try
    End Function

    ''' <summary>
    '''  Retorna la llista de totes les noticies
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function RetornaLlistaNoticies() As System.Data.Linq.ISingleResult(Of RetornaLlistaNoticiesResult)
        Try
            Return dc.RetornaLlistaNoticies()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorNoticiesBD_RetornaLlistaNoticies & ex.Message, vbExclamation)
            Return Nothing
        End Try

    End Function

    ''' <summary>
    '''  Retorna la llista de les noticies del perfil
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function RetornaLlistaNoticies(ByVal perfil As String) As System.Data.Linq.ISingleResult(Of RetornaLlistaNoticiesPerfilResult)
        Try
            Return dc.RetornaLlistaNoticiesPerfil(perfil)

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorNoticiesBD_RetornaLlistaNoticies & ex.Message, vbExclamation)
            Return Nothing
        End Try

    End Function

    'DELETE

    ''' <summary>
    ''' Elimina la noticia amb Id=id
    ''' </summary>
    ''' <param name="id"></param>
    ''' <remarks></remarks>
    Sub EliminaNoticia(ByVal id As String)
        Try
            dc.EliminaNoticia(id)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorNoticiesBD_EliminaNoticia & ex.Message, vbExclamation)
        End Try
    End Sub
End Class
