﻿
''' <summary>
''' Gestiona la comunicació entre l'aplicació i la BBDD en l'àmbit de USUARIS
''' </summary>
''' <remarks></remarks>
Public Class GestorUsuarisBD
    Dim dc As CampusNetDataContext = New CampusNetDataContext()
     'INSERT

    ''' <summary>
    ''' Inserta un nou usuari a la BBDD
    ''' </summary>
    ''' <param name="id">Nif del usuari</param>
    ''' <param name="nom">nom del usuari</param>
    ''' <param name="cognoms">cognoms del usuari</param>
    ''' <param name="dir">dir del usuari</param>
    ''' <param name="tel">tel del usuari</param>
    ''' <param name="mail">mail del usuari</param>
    ''' <param name="alta">alta del usuari</param>
    ''' <param name="perfil"> perfil del usuari</param>
    ''' <remarks></remarks>
    ''' <returns>0 si correcte ,1 altrament</returns>
    Function NouUsuari(ByVal id As String, ByVal nom As String, ByVal cognoms As String, ByVal dir As String, ByVal tel As String, ByVal mail As String, _
                  ByVal alta As Date, ByVal perfil As String) As Integer
        Dim resultat As Integer
        'calculem el nom d'usuari i la contrasenya per l'autenticació
        Dim nomUser As String = Left(nom, 1) & Left(cognoms, 8)
        Dim pass As String = "Campus" & Year(Today).ToString

        Try
            dc.InsertaUsuario(id, nom, cognoms, dir, tel, mail, alta, perfil, nomUser, pass)

            resultat = 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_NouUsuari & ex.Message)
            resultat = 1
        End Try
        Return resultat
    End Function

    ''' <summary>
    ''' Inserta un nou perfil a la taula de perfils
    ''' </summary>
    ''' <param name="descripcio">descripcio</param>
    ''' <remarks></remarks>
    ''' <returns>0 si correcte ,1 altrament</returns>
    Function NouPerfil(ByVal descripcio As String)
        Dim resultat As Integer
        Try
            dc.NouPerfil(descripcio)
            resultat = 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_NouPerfil & ex.Message)
            resultat = 1
        End Try
        Return resultat
    End Function

    'UPDATE

    ''' <summary>
    '''  Passa un usuari a estat inactiu
    ''' </summary>
    ''' <param name="id">id</param>
    ''' <remarks></remarks>
    Sub Usuari_A_Inactiu(ByVal id As String)
        Try
            dc.Usuari_a_inactiu(id)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_Usuari_A_Inactiu & ex.Message)
        End Try

    End Sub

    ''' <summary>
    '''  Passa un usuari a estat actiu
    ''' </summary>
    ''' <param name="id">id</param>
    ''' <remarks></remarks>
    Sub Usuari_A_actiu(ByVal id As String)
        Try
            dc.Usuari_a_ACTIU(id)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_Usuari_A_actiu & ex.Message, vbExclamation)
        End Try

    End Sub

    ''' <summary>
    ''' Actualitza les dades modificades d'un usuari
    ''' </summary>
    ''' <param name="id"></param>
    ''' <param name="nom"></param>
    ''' <param name="cognoms"></param>
    ''' <param name="dir"></param>
    ''' <param name="tel"></param>
    ''' <param name="mail"></param>
    ''' <param name="alta"></param>
    ''' <param name="perfil"></param>
    ''' <param name="nomUser"></param>
    ''' <remarks></remarks>
    ''' <returns>0 si correcte ,1 altrament</returns>
    Function ModificaUsuari(ByVal id As String, ByVal nom As String, ByVal cognoms As String, ByVal dir As String, ByVal tel As String, ByVal mail As String, _
                  ByVal alta As Date, ByVal perfil As String, ByVal nomUser As String, ByVal estat As String)
        Dim resultat As Integer
        Try
            dc.ModificaUsuari(id, nom, cognoms, dir, tel, mail, alta, perfil, nomUser, estat)
            If estat = 1 Then dc.Usuari_a_ACTIU(id)

            resultat = 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_ModificaUsuari & ex.Message)
            resultat = 1
        End Try
        Return resultat
    End Function

    ''' <summary>
    ''' Actualitza la paraula de pas d'un usuari
    ''' </summary>
    ''' <param name="idUser"></param>
    ''' <param name="pass"></param>
    ''' <returns>0 si correcte, 1 altrament</returns>
    ''' <remarks></remarks>
    Function ActualitzaPass(ByVal idUser As String, ByVal pass As String) As Integer
        Dim resultat As Integer = 0
        Try
            dc.ActualitzaPass(idUser, pass)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_ActualitzaPass & ex.Message)
            resultat = 1
        End Try
        Return resultat
    End Function

    'DELETE

    ''' <summary>
    '''  Elimina el usuari amb id=id
    ''' </summary>
    ''' <param name="id">id</param>
    ''' <remarks></remarks>
    Sub EliminaUsuari(ByVal id As String)
        Try
            dc.EliminaUsuari(id)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_EliminaUsuari & ex.Message, vbExclamation)
        End Try

    End Sub


    'SELECT

    ''' <summary>
    ''' Retorna si la paraula de pass correspón a un usuari 
    ''' </summary>
    ''' <param name="idUser"></param>
    ''' <param name="pass"></param>
    ''' <returns>0 si correcte, 1 altrament</returns>
    ''' <remarks></remarks>
    Function ValidaContrasenya(ByVal idUser As String, ByVal pass As String) As Integer
        Dim resultat As Integer = 1
        Try
            For Each Usuari In dc.ValidaPass(idUser, pass)
                If Usuari.Password.Trim(" ").Equals(pass) And Usuari.UserId.Trim(" ").Equals(idUser) Then resultat = 0
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_ValidaContrasenya & ex.Message, vbExclamation)
        End Try
        Return resultat
    End Function

    ''' <summary>
    ''' Retorna la llista dels perfils vàlids d'usuari
    ''' </summary>
    ''' <returns>llista dels perfils</returns>
    ''' <remarks></remarks>
    Function RetornaPerfils() As System.Data.Linq.ISingleResult(Of RetornaLlistaPerfilsResult)
        Try
            Return dc.RetornaLlistaPerfils()
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_RetornaLlistaPerfils & ex.Message)
            Return Nothing
        End Try
    End Function

    ''' <summary>
    ''' Retorna el usuari amb id=id
    ''' </summary>
    ''' <param name="id">id</param>
    ''' <returns>el usuari amb id=id</returns>
    ''' <remarks></remarks>
    Function RetornaUsuari(ByVal id As String) As System.Data.Linq.ISingleResult(Of RetornaUsuariResult)

        Try
            Return dc.RetornaUsuari(id)

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_RetornaUsuari & ex.Message)
            Return Nothing
        End Try
    End Function

    ''' <summary>
    ''' Comprova si un usuari está actiu
    ''' </summary>
    ''' <param name="idUser"></param>
    ''' <returns>true si actiu, false altrament</returns>
    ''' <remarks></remarks>
    Function esActiu(ByVal idUser As String) As Boolean
        Dim estat As Boolean = True
        Try
            For Each usuariCercat In dc.RetornaUsuari(idUser)
                If usuariCercat.Estat = 0 Then estat = False
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_RetornaUsuari & ex.Message)

        End Try
        Return estat
    End Function

    ''' <summary>
    ''' Retorna el nom i cognoms del usuari amb id=idUsuari
    ''' </summary>
    ''' <param name="idUsuari"></param>
    ''' <returns>nom i cognoms si correcte, "" altrament</returns>
    ''' <remarks></remarks>
    Function ObteNomiCognomsUsuari(ByVal idUsuari As String) As String
        Dim nom As String = ""
        Try
            For Each Usuari In RetornaUsuari(idUsuari)
                nom = Usuari.Nom.Trim(" ") & " " & Usuari.Cognoms
            Next

        Catch ex As Exception

        End Try
        Return nom
    End Function

    ''' <summary>
    ''' Carrega les dades del usuari actiu
    ''' </summary>
    ''' <param name="nomUser">nomUser</param>
    ''' <param name="pass">pass</param>
    ''' <remarks></remarks>
    Sub CarregaUsuariActiu(ByVal nomUser As String, ByVal pass As String)
        Try
            For Each user In dc.RetornaUsuariAutenticat(nomUser, pass)
                UsuariActiu.idUsuari = user.Id
                UsuariActiu.nomUsuari = user.Nom
                UsuariActiu.cognomUsuari = user.Cognoms
                UsuariActiu.dirUsuari = user.Direccio
                UsuariActiu.telUsuari = user.Telefon
                UsuariActiu.mailUsuari = user.Email
                UsuariActiu.estatUsuari = user.Estat
                UsuariActiu.dataAlta = user.DataAlta
                UsuariActiu.passUsuari = user.Password
                UsuariActiu.userUsuari = user.NomUsuari
                UsuariActiu.perfilUsuari = user.Perfil
                Exit For

            Next

        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' Retorna la llista de tutors existents al campus
    ''' </summary>
    ''' <returns>llista si correcte, nothing altrament</returns>
    ''' <remarks></remarks>
    Function RetornaTutors() As System.Data.Linq.ISingleResult(Of RetornaTutorsResult)
        Try
            Return dc.RetornaTutors

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_RetornaTutors & ex.Message)
            Return Nothing
        End Try
    End Function

    ''' <summary>
    ''' Retorna la llista d'usuaris amb cognom similar a cognomUsuari
    ''' </summary>
    ''' <param name="cognomUsuari"></param>
    ''' <returns>llista si correcte, nothing altrament</returns>
    ''' <remarks></remarks>
    Function RetornaUsuariCognoms(ByVal cognomUsuari As String) As IEnumerable
        Dim consulta As IEnumerable
        Try
            consulta = From usersCercats In dc.Usuaris
                    Where usersCercats.Cognoms.Contains(cognomUsuari)
                    Select usersCercats
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_RetornaUsuari & ex.Message)

            consulta = Nothing
        End Try
        Return consulta
    End Function

    ''' <summary>
    ''' Retorna la llista d'usuaris
    ''' </summary>
    ''' <returns>llista si correcte, nothing altrament</returns>
    ''' <remarks></remarks>
    Function RetornallistaUsuaris() As System.Data.Linq.ISingleResult(Of RetornaLlistaUsuarisResult)
        Try
            Return dc.RetornaLlistaUsuaris()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorUsuarisBD_RetornaUsuari & ex.Message)
            Return Nothing
        End Try
    End Function

End Class
