﻿Public Class GestioCursosAdmin
    Inherits System.Web.UI.Page

    Dim gestor As GestorCursosBD = New GestorCursosBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()

    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'un nou curs
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxIdCurs.Text = "" Or Len(TextBoxIdCurs.Text) > 15 Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_Id, vbInformation)
            resultat = 1
        End If
        If TextBoxNomCurs.Text = "" Or Len(TextBoxNomCurs.Text) > 30 Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_Nom, vbInformation)
            resultat = 1
        End If
        If LabelDataInici.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_DataInici, vbInformation)
            resultat = 1
        End If
        If LabelTutor.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_Tutor, vbInformation)
            resultat = 1
        End If
        If LabelDataFi.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_DataFi, vbInformation)
            resultat = 1
        End If
        If resultat = 0 Then
            If CDate(LabelDataFi.Text) < CDate(LabelDataInici.Text) Then
                MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_ConsistenciaDatas, vbInformation)
                resultat = 1


            End If
        End If

        
        Return resultat

    End Function



    ''' <summary>
    ''' Afegeix un nou curs
    ''' </summary>
    ''' <remarks></remarks>
    Sub NouCurs()
        'Comprovem compatibilitats 


        'preparem el missatge de comprovació
        Dim checkAlta As String = "Comprovem dades nou curs:" & vbCrLf & vbCrLf _
                                 & "Id :" & TextBoxIdCurs.Text & vbCrLf _
                                 & "Nom :" & TextBoxNomCurs.Text & vbCrLf _
                                 & "Descripció :" & TextBoxDescCurs.Text & vbCrLf _
                                 & "Tutor :" & LabelTutor.Text & vbCrLf _
                                 & "Data inici :" & LabelDataInici.Text & vbCrLf _
                                 & "Data fi :" & LabelDataFi.Text & vbCrLf & vbCrLf _
                                 & "Són correctes ? "

        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel Or MsgBoxStyle.Information
        Dim resposta As MsgBoxResult

        'generem el missatge de comprovació
        resposta = MsgBox(checkAlta, style)

        'si es ok endavant
        If resposta = MsgBoxResult.Ok Then
            Try
                Dim resultat As Integer = gestor.NouCurs(TextBoxIdCurs.Text, TextBoxNomCurs.Text, TextBoxDescCurs.Text, LabelIdTutor.Text, LabelDataInici.Text, LabelDataFi.Text)

                If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAltaCurs_NouCurs_OK, LabelInfo, Timer1)
            Catch ex As Exception
                MsgBox(Resources.Missatges.Info_PaginaAltaCurs_NouCurs_KO & ex.Message)
            End Try
        Else ' si no es correcte cancelem l'alta
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAltaCurs_NouCurs_CancelatPerUser, LabelInfo, Timer1)
        End If



    End Sub

    ''' <summary>
    ''' Carrega la llista de tutors
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaTutors()
        GridViewTutors.DataSource = gestorUsuaris.RetornaTutors
        GridViewTutors.DataBind()

    End Sub

    ''' <summary>
    ''' Carrega les dades d'un tutor
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaTutor()
        Dim selectRow As GridViewRow = GridViewTutors.SelectedRow
        'recuperem la FAQ
        Try
            For Each tutor In gestorUsuaris.RetornaUsuari(selectRow.Cells(1).Text)
                LabelIdTutor.Text = tutor.Id
                LabelTutor.Text = tutor.Nom & " " & tutor.Cognoms
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_SeleccionaTutor & ex.Message, vbExclamation)

        End Try
        
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaLlistaTutors()

        End If
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub ButtonGravar_Click(sender As Object, e As EventArgs) Handles ButtonGravar.Click

        If ComprovaDades() = 0 Then NouCurs()

    End Sub

   
    Protected Sub CalendarDataIniciCurs_SelectionChanged(sender As Object, e As EventArgs) Handles CalendarDataIniciCurs.SelectionChanged
        LabelDataInici.Text = CalendarDataIniciCurs.SelectedDate
    End Sub

    Protected Sub CalendarDataFi_SelectionChanged(sender As Object, e As EventArgs) Handles CalendarDataFi.SelectionChanged
        LabelDataFi.Text = CalendarDataFi.SelectedDate
    End Sub

    Protected Sub GridViewTutors_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewTutors.SelectedIndexChanged
        SeleccionaTutor()

    End Sub
    Protected Sub GridViewTutors_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewTutors.PageIndexChanging
        GridViewTutors.PageIndex = e.NewPageIndex
        CarregaLlistaTutors()
    End Sub
End Class