﻿Public Class AltaUsuari
    Inherits System.Web.UI.Page
    Dim gestor As GestorUsuarisBD = New GestorUsuarisBD()


    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'un nou usuari
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxId.Text = "" Or Len(TextBoxId.Text) > 9 Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Id, vbInformation)
            resultat = 1
        End If
        If TextBoxNom.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Nom, vbInformation)
            resultat = 1
        End If
        If TextBoxCognoms.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_CogNom, vbInformation)
            resultat = 1
        End If
        If TextBoxAdreca.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Adreca, vbInformation)
            resultat = 1
        End If
        If TextBoxTelefon.Text = "" Or Len(TextBoxTelefon.Text) > 9 Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Tel, vbInformation)
            resultat = 1
        End If
        If Not Regex.IsMatch(TextBoxEmail.Text, "^([\w-]+\.)*?[\w-]+@[\w-]+\.([\w-]+\.)*?[\w]+$") Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Email, vbInformation)
            resultat = 1
        End If


        Return resultat

    End Function


    ''' <summary>
    ''' Afegeix un nou usuari
    ''' </summary>
    ''' <remarks></remarks>
    Sub NouUsuari()
        'Comprovem compatibilitats 


        'preparem el missatge de comprovació
        Dim checkAlta As String = "Comprovem dades nou usuari:" & vbCrLf & vbCrLf _
                                 & "Id :" & TextBoxId.Text & vbCrLf _
                                 & "Nom :" & TextBoxNom.Text & vbCrLf _
                                 & "Cognoms :" & TextBoxCognoms.Text & vbCrLf _
                                 & "Adreça :" & TextBoxAdreca.Text & vbCrLf _
                                 & "Telèfon :" & TextBoxTelefon.Text & vbCrLf _
                                 & "Email :" & TextBoxEmail.Text & vbCrLf _
                                 & "Data alta :" & CalendarDataAlta.SelectedDate.ToString & vbCrLf _
                                 & "Perfil :" & LabelPerfil.Text & vbCrLf & vbCrLf _
                                 & "Són correctes ? "

        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel Or MsgBoxStyle.Information
        Dim resposta As MsgBoxResult

        'generem el missatge de comprovació
        resposta = MsgBox(checkAlta, style)

        'si es ok endavant
        If resposta = MsgBoxResult.Ok Then
            Try
                Dim resultat As Integer = gestor.NouUsuari(TextBoxId.Text, TextBoxNom.Text, TextBoxCognoms.Text, TextBoxAdreca.Text, TextBoxTelefon.Text, _
                                 TextBoxEmail.Text, CalendarDataAlta.SelectedDate, LabelPerfil.Text)

                If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAltaUsuari_NouUsuari_OK, LabelInfo, Timer1)
            Catch ex As Exception
                MsgBox(Resources.Missatges.Info_PaginaAltaUsuari_NouUsuari_KO & ex.Message)
            End Try
        Else ' si no es correcte cancelem l'alta
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAltaUsuari_NouPerfil_CancelatPerUser, LabelInfo, Timer1)
        End If



    End Sub

    ''' <summary>
    ''' Carrega la llista de perfils al combo de perfils
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaPerfils()
        'netegem el combo
        DropDownListPerfils.Items.Clear()
        Dim primer As String = ""
        Try
            'Carreguem el combo

            Dim posPrimer As Integer = 1
            For Each perfil In gestor.RetornaPerfils
                DropDownListPerfils.Items.Add(perfil.Descripcio)
                If posPrimer = 1 Then primer = perfil.Descripcio
                posPrimer = posPrimer + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_CarregaLlistaPerfils & ex.Message, vbExclamation)
        End Try
        LabelPerfil.Text = primer



    End Sub

    ''' <summary>
    ''' Afegeix un nou perfil
    ''' </summary>
    ''' <param name="descripcio">descripcio</param>
    ''' <remarks></remarks>
    Sub NouPerfil(ByVal descripcio As String)
        Dim msg As String
        Try
            gestor.NouPerfil(descripcio)
            'mostrem missatge ok
            msg = Resources.Missatges.Info_PaginaAltaUsuari_NouPerfil_OK
        Catch ex As Exception
            'mostrem missatge ko
            msg = Resources.Missatges.Info_PaginaAltaUsuari_NouPerfil_KO
        End Try
        Utils.MostrarInformacioAccio(msg, LabelInfo, Timer1)

    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaLlistaPerfils()
            LabelAlta.Text = Today.ToString
        End If


    End Sub

    Protected Sub ButtonAfegirPerfil_Click(sender As Object, e As EventArgs) Handles ButtonAfegirPerfil.Click
        'controlem que el text no sigui buit
        If TextBoxNouPerfil.Text = "" Then
            MsgBox(Resources.Missatges.Avis_PaginaAltaUsuari_DescripcioBuida, vbInformation)
        Else
            NouPerfil(TextBoxNouPerfil.Text)
        End If
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub DropDownListPerfils_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownListPerfils.SelectedIndexChanged
        LabelPerfil.Text = DropDownListPerfils.Text 'mostrem el perfil seleccionat
    End Sub

    Protected Sub ButtonGravar_Click(sender As Object, e As EventArgs) Handles ButtonGravar.Click
        If Page.IsValid Then
            If ComprovaDades() = 0 Then NouUsuari()
        End If
    End Sub

    Protected Sub CalendarDataAlta_SelectionChanged(sender As Object, e As EventArgs) Handles CalendarDataAlta.SelectionChanged
        LabelAlta.Text = CalendarDataAlta.SelectedDate
    End Sub
End Class