﻿Public Class AlumnesCurs
    Inherits System.Web.UI.Page
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()
    Dim gestorAlumnes As GestorUsuarisBD = New GestorUsuarisBD()


    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'una assignació
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxIdCurs.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAlumnesCurs_ComprovaDades_IdCurs, vbInformation)
            resultat = 1
        End If
        If TextBoxIdAlumne.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAlumnesCurs_ComprovaDades_IdAlumne, vbInformation)
            resultat = 1
        End If
       
        Return resultat

    End Function

    ''' <summary>
    ''' Retorna els usuaris cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCercaAlumnes()
        Try
            If DropDownListCercaCampAlumne.Text = "Id" Then
                GridViewAlumnes.DataSource = gestorAlumnes.RetornaUsuari(TextBoxIdAlumne.Text)

            ElseIf DropDownListCercaCampAlumne.Text = "Cognoms" Then
                GridViewAlumnes.DataSource = gestorAlumnes.RetornaUsuariCognoms(TextBoxNomAlumne.Text)

            End If
            GridViewAlumnes.DataBind()
            'no mostrem un alumne inactiu
            For Each alumneTrobat As GridViewRow In GridViewAlumnes.Rows
                If alumneTrobat.Cells(8).Text = 0 Then alumneTrobat.Visible = False
            Next

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaConsultaUsuari_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    ''' Retorna els cursos cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCercaCursos()
        Try
            If DropDownListCercaCampCurs.Text = "Id" Then
                GridViewCursos.DataSource = gestorCursos.RetornaCurs(TextBoxIdCurs.Text)
            ElseIf DropDownListCercaCampCurs.Text = "Nom" Then
                GridViewCursos.DataSource = gestorCursos.RetornaCursosNom(TextBoxNomCurs.Text)
            End If
            GridViewCursos.DataBind()
            For Each tutor As GridViewRow In GridViewCursos.Rows
                'convertim id a nom i cognoms
                tutor.Cells(6).Text = gestorAlumnes.ObteNomiCognomsUsuari(tutor.Cells(6).Text)

            Next
            GridViewAlumnesCurs.DataSource = Nothing
            GridViewAlumnesCurs.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaBaixaCursos_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    '''  Carrega les dades del curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaCurs()
        Dim selectRow As GridViewRow = GridViewCursos.SelectedRow
        Try
            For Each curs In gestorCursos.RetornaCurs(selectRow.Cells(1).Text)
                TextBoxIdCurs.Text = curs.Id
                TextBoxNomCurs.Text = curs.Nom

            Next
            CarregaLlistaAlumnesCurs()
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaBaixaCursos_CarregaResultatCerca & ex.Message)
        End Try



    End Sub

    ''' <summary>
    ''' Carrega la llista dels alumnes assignats al curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaAlumnesCurs()
        Try
            Dim index As Integer = 1
            
            GridViewAlumnesCurs.DataSource = gestorCursos.RetornaLlistaAlumnesCurs(TextBoxIdCurs.Text)
            GridViewAlumnesCurs.DataBind()
            GridViewAlumnesCurs.Caption = "Llista Alumnes del curs " & TextBoxIdCurs.Text

            For Each alumne As GridViewRow In GridViewAlumnesCurs.Rows
                'convertim id a nom i cognoms
                alumne.Cells(0).Text = gestorAlumnes.ObteNomiCognomsUsuari(alumne.Cells(0).Text)

            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAlumnesCurs_CarregaLlistaAlumnesCurs & ex.Message, vbExclamation)

        End Try
    End Sub

    ''' <summary>
    '''  Carrega les dades del usuari seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaUsuari()
        Dim selectRow As GridViewRow = GridViewAlumnes.SelectedRow
        For Each alumne In gestorAlumnes.RetornaUsuari(selectRow.Cells(1).Text)
            TextBoxIdAlumne.Text = alumne.Id
            TextBoxNomAlumne.Text = alumne.Cognoms

        Next

        
    End Sub


    ''' <summary>
    ''' Assigna l'alumne seleccionat al curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub AssignarAlumne()
        Try
            If gestorCursos.AssignaAlumne(TextBoxIdAlumne.Text, TextBoxIdCurs.Text) = 0 Then
                'èxit
                Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAlumnesCurs_AssignarAlumne_OK, LabelInfo, Timer1)
                CarregaLlistaAlumnesCurs()
            Else
                Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAlumnesCurs_AssignarAlumne_KO, LabelInfo, Timer1)
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    ''' <summary>
    ''' Desassigna l'alumne seleccionat al curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub DesassignaAlumne()
        Try
            gestorCursos.EliminaAssignacioAlumne(TextBoxIdAlumne.Text, TextBoxIdCurs.Text)
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAlumnesCurs_DesassignaAlumne_OK, LabelInfo, Timer1)
            CarregaLlistaAlumnesCurs()
        Catch ex As Exception
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAlumnesCurs_DesassignaAlumne_KO, LabelInfo, Timer1)

        End Try
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub GridViewCursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewCursos.SelectedIndexChanged
        SeleccionaCurs()
    End Sub

    Protected Sub ButtonCercaCurs_Click(sender As Object, e As EventArgs) Handles ButtonCercaCurs.Click
        CarregaResultatCercaCursos()
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub GridViewAlumnes_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewAlumnes.SelectedIndexChanged
        SeleccionaUsuari()
    End Sub

    Protected Sub ButtonCercaAlumne_Click(sender As Object, e As EventArgs) Handles ButtonCercaAlumne.Click
        CarregaResultatCercaAlumnes()
    End Sub

    Protected Sub ButtonAfegeix_Click(sender As Object, e As EventArgs) Handles ButtonAfegeix.Click
        If ComprovaDades() = 0 Then AssignarAlumne()

    End Sub

    Protected Sub ButtonElimina_Click(sender As Object, e As EventArgs) Handles ButtonElimina.Click
        If ComprovaDades() = 0 Then DesassignaAlumne()

    End Sub
    Protected Sub GridViewCursos_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewCursos.PageIndexChanging
        GridViewCursos.PageIndex = e.NewPageIndex

        CarregaResultatCercaCursos()


    End Sub

    Protected Sub GridViewAlumnesCurs_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewAlumnesCurs.PageIndexChanging
        GridViewAlumnesCurs.PageIndex = e.NewPageIndex

        CarregaLlistaAlumnesCurs()


    End Sub
    Protected Sub GridViewAlumnes_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewAlumnes.PageIndexChanging
        GridViewAlumnes.PageIndex = e.NewPageIndex

        CarregaResultatCercaAlumnes()


    End Sub
End Class