﻿Public Class Avaluacio
    Inherits System.Web.UI.Page

    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()

    ''' <summary>
    ''' Carrega la llista de cursos del alumne
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaCursosAlumne()
        Try
            Dim i As Integer = 1
            For Each Curs In gestorCursos.RetornaLlistaCursosAlumne(UsuariActiu.idUsuari)
                DropDownListCursos.Items.Add(Curs.Id)
                If i = 1 Then LabelCurs.Text = Curs.Id
                i = i + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaCurs_CarregaCursosAlumne & ex.Message, vbExclamation)

        End Try
    End Sub

    ''' <summary>
    ''' Carrega les dades del alumne
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaDadesAlumne()
        Try
            LabelIdAlumne.Text = UsuariActiu.idUsuari
            LabelNomAlumne.Text = gestorUsuaris.ObteNomiCognomsUsuari(UsuariActiu.idUsuari)

        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' Carrega la llista de test realitzats per el alumne
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaTestRealitzats()
        Try
            GridViewTestRealitzats.DataSource = gestorCursos.RetornaLlistaTestRealitzatsAlumne(UsuariActiu.idUsuari)
            GridViewTestRealitzats.DataBind()
            For Each registre As GridViewRow In GridViewTestRealitzats.Rows
                Dim idTest As TableCell = New TableCell() 'afegim el nom del test al final 
                idTest.Text = gestorCursos.RetornaNomTest(registre.Cells(1).Text)
                registre.Cells.Add(idTest)
                registre.Cells(3).Text = gestorUsuaris.ObteNomiCognomsUsuari(registre.Cells(3).Text)
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_CarregaTestRealitzats & ex.Message, vbExclamation)
        End Try
    End Sub

    ''' <summary>
    ''' Selecciona les dades del test escollit
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaTest()
        Dim selectRow As GridViewRow = GridViewTestRealitzats.SelectedRow
        Try
            LabelIdTest.Text = selectRow.Cells(1).Text
            CarregaRespostesEscollides()
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_SeleccionaTest & ex.Message, vbExclamation)

        End Try
    End Sub

    ''' <summary>
    ''' Carrega la llista de respostes escollides del test
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaRespostesEscollides()
        Try
            GridViewRespostesEscollides.DataSource = gestorCursos.RetornaLlistaRespostesEscollides(LabelIdAlumne.Text, LabelIdTest.Text)
            GridViewRespostesEscollides.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_CarregaRespostesEscollides & ex.Message, vbExclamation)
        End Try
    End Sub

    ''' <summary>
    ''' Obté la nota del alumne en el curs
    ''' </summary>
    ''' <remarks></remarks>
    Sub RecuperaNota()
        Try
            LabelNota.Text = gestorCursos.RetornaNotaAlumne(LabelIdAlumne.Text, LabelCurs.Text)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_RecuperaNota & ex.Message, vbExclamation)

        End Try
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaCursosAlumne()
            CarregaDadesAlumne()
            CarregaTestRealitzats()
            RecuperaNota()
        End If
        
    End Sub

    Protected Sub DropDownListCursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownListCursos.SelectedIndexChanged
        LabelCurs.Text = DropDownListCursos.Text
        RecuperaNota()
    End Sub
    Protected Sub GridViewTestRealitzats_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewTestRealitzats.SelectedIndexChanged
        SeleccionaTest()
    End Sub
    Protected Sub GridViewTestRealitzats_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewTestRealitzats.PageIndexChanging
        GridViewTestRealitzats.PageIndex = e.NewPageIndex

        CarregaTestRealitzats()


    End Sub
End Class