﻿Public Class BaixaCursos
    Inherits System.Web.UI.Page
    Dim gestor As GestorCursosBD = New GestorCursosBD()


    ''' <summary>
    ''' Retorna els cursos cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCerca()
        Try
            If DropDownListCerca.Text = "Id" Then
                GridViewResultatCerca.DataSource = gestor.RetornaCurs(TextBoxCerca.Text)

            ElseIf DropDownListCerca.Text = "Nom" Then
                GridViewResultatCerca.DataSource = gestor.RetornaCursosNom(TextBoxCerca.Text)

            End If
            GridViewResultatCerca.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaBaixaCursos_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    '''  Carrega les dades del curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaCurs()
        Dim selectRow As GridViewRow = GridViewResultatCerca.SelectedRow
        Try
            For Each curs In gestor.RetornaCurs(selectRow.Cells(1).Text)
                TextBoxIdCurs.Text = curs.Id
                TextBoxDatFinal.Text = curs.DataFi
                TextBoxDatInici.Text = curs.DataInici
                TextBoxDescCurs.Text = curs.Descripcio
                TextBoxNomCurs.Text = curs.Nom
                TextBoxTutor.Text = curs.TutorPrincipal

            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaBaixaCursos_CarregaResultatCerca & ex.Message)
        End Try
        


    End Sub


    ''' <summary>
    ''' Elimina definitivament un curs
    ''' </summary>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    ''' 
    Function EliminaCurs() As Integer
        Try
            'preparem el missatge de comprovació
            Dim checkBaixa As String = Resources.Missatges.Info_PaginaBaixaCursos_EliminaCurs

            Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel Or MsgBoxStyle.Information
            Dim resposta As MsgBoxResult

            'generem el missatge de comprovació
            resposta = MsgBox(checkBaixa, style)

            'si es ok endavant
            If resposta = MsgBoxResult.Ok Then
                gestor.EliminaCurs(TextBoxIdCurs.Text)
                CarregaResultatCerca()
                Return 0
            Else
                Return 1
            End If

        Catch ex As Exception
            Return 1
        End Try
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub ButtonCercaCamp_Click(sender As Object, e As EventArgs) Handles ButtonCercaCamp.Click
        CarregaResultatCerca()
    End Sub
    Protected Sub GridViewResultatCerca_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewResultatCerca.SelectedIndexChanged
        SeleccionaCurs()
    End Sub
    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub ButtonElimina_Click(sender As Object, e As EventArgs) Handles ButtonElimina.Click
        If EliminaCurs() = 0 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaBaixaCurs_EliminaCurs_OK, LabelInfo, Timer1)

        Else
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaBaixaCurs_EliminaCurs_KO, LabelInfo, Timer1)

        End If
        
    End Sub
End Class