﻿Public Class BaixaUsuari
    Inherits System.Web.UI.Page
    Dim gestor As GestorUsuarisBD = New GestorUsuarisBD()
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()
    Dim missatgeDependencies As String

    ''' <summary>
    ''' Retorna els usuaris cercats
    ''' </summary>
    ''' <param name="id">id</param>
    ''' <remarks></remarks>
    Sub CarregaResultatCerca(ByVal id As String)
        Try
            If DropDownListCerca.Text = "Id" Then
                GridViewResultatCerca.DataSource = gestor.RetornaUsuari(TextBoxId.Text)

            ElseIf DropDownListCerca.Text = "Cognoms" Then
                GridViewResultatCerca.DataSource = gestor.RetornaUsuariCognoms(TextBoxCognoms.Text)

            End If
            GridViewResultatCerca.DataBind()
            

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaConsultaUsuari_CarregaResultatCerca & ex.Message)
        End Try
        ButtonInactiu.Visible = False

    End Sub


    ''' <summary>
    ''' Carrega la llista de perfils al combo de perfils
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaPerfils()
        'netegem el combo
        DropDownListPerfils.Items.Clear()
        Dim primer As String = ""
        Try
            'Carreguem el combo

            Dim posPrimer As Integer = 1
            For Each perfil In gestor.RetornaPerfils
                DropDownListPerfils.Items.Add(perfil.Descripcio)
                If posPrimer = 1 Then primer = perfil.Descripcio
                posPrimer = posPrimer + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_CarregaLlistaPerfils & ex.Message, vbExclamation)
        End Try
        LabelPerfil.Text = primer



    End Sub

    ''' <summary>
    '''  Carrega les dades del usuari seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaUsuari()

        Dim selectRow As GridViewRow = GridViewResultatCerca.SelectedRow
        For Each usuariSeleccionat In gestor.RetornaUsuari(selectRow.Cells(1).Text)
            TextBoxId.Text = usuariSeleccionat.Id
            TextBoxNom.Text = usuariSeleccionat.Nom
            TextBoxCognoms.Text = usuariSeleccionat.Cognoms
            TextBoxAdreca.Text = usuariSeleccionat.Direccio
            TextBoxTelefon.Text = usuariSeleccionat.Telefon
            TextBoxEmail.Text = usuariSeleccionat.Email
            LabelDataAlta.Text = usuariSeleccionat.DataAlta
            TextBoxMotiuBaixa.Text = usuariSeleccionat.MotiuBaixa
            TextBoxNomUser.Text = usuariSeleccionat.NomUsuari
            LabelPerfil.Text = usuariSeleccionat.Perfil
            If usuariSeleccionat.Estat = 1 Then ButtonInactiu.Visible = True ' si el usuari està actiu mostrem el boto

        Next




    End Sub


    ''' <summary>
    '''  Passa un usuari a estat inactiu
    ''' </summary>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    Function Usuari_a_Inactiu() As Integer
        Try
            'comprovem dependències del usuari
            If TeDependencies() = False Then
                gestor.Usuari_A_Inactiu(TextBoxId.Text)
                Return 0
            Else
                MsgBox(missatgeDependencies, vbInformation)
                Return 1
            End If
            
        Catch ex As Exception
            Return 1
        End Try
    End Function

    Function TeDependencies() As Boolean
        Dim dependencia As Boolean = False
        Try
            'Comprovem si el usuari te dependències
            If LabelPerfil.Text.Contains("Tutor") Then
                'comprovem que no sigui assignat a cap curs com tutor principal
                Dim numCursos As Integer = 0
                Dim llistaCursos As String = "El tutor " & gestor.ObteNomiCognomsUsuari(TextBoxId.Text) & " està assignat al curs " & vbCrLf
                For Each cursTutoritzat In gestorCursos.RetornaLlistaCursosTutor(TextBoxId.Text)
                    numCursos = numCursos + 1
                    llistaCursos = llistaCursos & cursTutoritzat.Nom & vbCrLf
                Next
                If numCursos > 0 Then
                    dependencia = True
                    llistaCursos = llistaCursos & Resources.Missatges.Info_PaginaModificaUsuari_TeDependencies_Tutor

                    missatgeDependencies = llistaCursos
                End If

            ElseIf LabelPerfil.Text.Contains("Alumne") Then
                'comprovem que no sigui assignat a cap curs com alumne
                Dim numCursos As Integer = 0
                Dim llistaCursos As String = "El alumne " & gestor.ObteNomiCognomsUsuari(TextBoxId.Text) & " està assignat al curs " & vbCrLf
                For Each cursCursat In gestorCursos.RetornaLlistaCursosAlumne(TextBoxId.Text)
                    numCursos = numCursos + 1
                    llistaCursos = llistaCursos & cursCursat.Nom & vbCrLf
                Next
                If numCursos > 0 Then
                    dependencia = True
                    llistaCursos = llistaCursos & Resources.Missatges.Info_PaginaModificaUsuari_TeDependencies_Alumne
                    missatgeDependencies = llistaCursos
                End If
            End If
        Catch ex As Exception

        End Try
        Return dependencia
    End Function
    ''' <summary>
    ''' Elimina definitivament un usuari
    ''' </summary>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    ''' 
    Function EliminaUsuari() As Integer

        Try
            If UsuariActiu.idUsuari.Contains(TextBoxId.Text) Then
                Return 1
            Else
                gestor.EliminaUsuari(TextBoxId.Text)
                CarregaResultatCerca(TextBoxId.Text)
                Return 0
            End If
            
        Catch ex As Exception
            Return 1
        End Try
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaLlistaPerfils()

        End If
    End Sub

    Protected Sub ButtonCercaCamp_Click(sender As Object, e As EventArgs) Handles ButtonCercaCamp.Click
        CarregaResultatCerca(TextBoxId.Text)
    End Sub

    Protected Sub GridViewResultatCerca_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewResultatCerca.SelectedIndexChanged
        SeleccionaUsuari()
    End Sub
    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub ButtonInactiu_Click(sender As Object, e As EventArgs) Handles ButtonInactiu.Click
        If Usuari_a_Inactiu() = 0 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaBaixaUsuari_Usuari_a_inactiu_OK, LabelInfo, Timer1)

        Else
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaBaixaUsuari_Usuari_a_inactiu_KO, LabelInfo, Timer1)

        End If
        ButtonInactiu.Visible = False
    End Sub

    
End Class