﻿Public Class ConsultaUsuari
    Inherits System.Web.UI.Page
    Dim gestor As GestorUsuarisBD = New GestorUsuarisBD()

    ''' <summary>
    '''  Carrega les dades del usuari seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaUsuari()

        Dim selectRow As GridViewRow = GridViewResultatCerca.SelectedRow
        For Each usuariSeleccionat In gestor.RetornaUsuari(selectRow.Cells(1).Text)
            TextBoxId.Text = usuariSeleccionat.Id
            TextBoxNom.Text = usuariSeleccionat.Nom
            TextBoxCognoms.Text = usuariSeleccionat.Cognoms
            TextBoxAdreca.Text = usuariSeleccionat.Direccio
            TextBoxTelefon.Text = usuariSeleccionat.Telefon
            TextBoxEmail.Text = usuariSeleccionat.Email
            TextBoxMotiuBaixa.Text = usuariSeleccionat.MotiuBaixa
            TextBoxNomUser.Text = usuariSeleccionat.NomUsuari
            LabelPerfil.Text = usuariSeleccionat.Perfil


        Next

        


    End Sub

    ''' <summary>
    ''' Retorna els usuaris cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCerca()
        Try
            If DropDownListCerca.Text = "Id" Then
                GridViewResultatCerca.DataSource = gestor.RetornaUsuari(TextBoxId.Text)

            ElseIf DropDownListCerca.Text = "Cognoms" Then
                GridViewResultatCerca.DataSource = gestor.RetornaUsuariCognoms(TextBoxCognoms.Text)

            End If
            GridViewResultatCerca.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaConsultaUsuari_CarregaResultatCerca & ex.Message)
        End Try
    End Sub


    ''' <summary>
    ''' Carrega la llista de perfils al combo de perfils
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaPerfils()
        'netegem el combo
        DropDownListPerfils.Items.Clear()
        Dim primer As String = ""
        Try
            'Carreguem el combo

            Dim posPrimer As Integer = 1
            For Each perfil In gestor.RetornaPerfils
                DropDownListPerfils.Items.Add(perfil.Descripcio)
                If posPrimer = 1 Then primer = perfil.Descripcio
                posPrimer = posPrimer + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_CarregaLlistaPerfils & ex.Message, vbExclamation)
        End Try
        LabelPerfil.Text = primer



    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaLlistaPerfils()

        End If
    End Sub

    Protected Sub ButtonCercaCamp_Click(sender As Object, e As EventArgs) Handles ButtonCercaCamp.Click
        CarregaResultatCerca()
    End Sub

    Protected Sub GridViewResultatCerca_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewResultatCerca.SelectedIndexChanged
        SeleccionaUsuari()
    End Sub
End Class