﻿Public Class ContingutCurs
    Inherits System.Web.UI.Page
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()


    ''' <summary>
    ''' Comprova la compatibilitat de les dades del nou contingut
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxNomNou.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaContingutCurs_ComprovaDades_Nom, vbInformation)
            resultat = 1
        End If
        If TextBoxTipusNou.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaContingutCurs_ComprovaDades_Tipus, vbInformation)
            resultat = 1
        End If
        If TextBoxIdCurs.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaContingutCurs_ComprovaDades_SeleccionaCurs, vbInformation)
            resultat = 1
        End If
        Return resultat

    End Function

    ''' <summary>
    ''' Carrega la llista de cursos assignats a un tutor
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaCursosTutor()
        Try
            GridViewCursos.DataSource = gestorCursos.RetornaLlistaCursosTutor(UsuariActiu.idUsuari)
            GridViewCursos.DataBind()
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAlumnesCurs_CarregaCursosTutor & ex.Message, vbExclamation)

        End Try
    End Sub
   
    ''' <summary>
    '''  Carrega les dades del curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaCurs()
        Dim selectRow As GridViewRow = GridViewCursos.SelectedRow
        Try
            For Each curs In gestorCursos.RetornaCurs(selectRow.Cells(1).Text)
                TextBoxIdCurs.Text = curs.Id
                TextBoxNomCurs.Text = curs.Nom

            Next
            
            CarregaLlistaContingutsCurs()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_ContingutCurs_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    '''  Carrega les dades del contingut seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaContingut()
        Dim selectRow As GridViewRow = GridViewContinguts.SelectedRow
        Try
            For Each contingut In gestorCursos.RetornaContingut(selectRow.Cells(1).Text)
                TextBoxIdContingut.Text = contingut.Id
                TextBoxDescNou.Text = contingut.Descripcio
                TextBoxNomNou.Text = contingut.Nom
                TextBoxTipusNou.Text = contingut.Tipus

            Next

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_ContingutCurs_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    ''' Carrega la llista dels continguts assignats al curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaContingutsCurs()
        Try
            Dim index As Integer = 1

            GridViewLlistaContinguts.DataSource = gestorCursos.RetornaLlistaContingutsCurs(TextBoxIdCurs.Text)
            GridViewLlistaContinguts.DataBind()
            GridViewLlistaContinguts.Caption = "Llista continguts del curs " & TextBoxIdCurs.Text
          

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAlumnesCurs_CarregaLlistaContingutsCurs & ex.Message, vbExclamation)

        End Try
    End Sub

   


    ''' <summary>
    ''' Retorna els continguts cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCercaContinguts()
        Try
            If DropDownListCerca.Text = "Id" Then
                GridViewContinguts.DataSource = gestorCursos.RetornaContingut(TextBoxIdContingut.Text)
            ElseIf DropDownListCerca.Text = "Nom" Then
                GridViewContinguts.DataSource = gestorCursos.RetornaContingutNom(TextBoxNomNou.Text)
            End If

            GridViewContinguts.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAlumnesCurs_CarregaLlistaContingutsCurs & ex.Message)
        End Try

    End Sub


    ''' <summary>
    ''' Neteja les dades mostrades
    ''' </summary>
    ''' <remarks></remarks>
    Sub NetejaPantalla()
        TextBoxDescNou.Text = ""
        TextBoxNomNou.Text = ""
        TextBoxDescNou.Text = ""

    End Sub

    ''' <summary>
    '''  Assigna un nou element a la llista
    ''' </summary>
    ''' <remarks></remarks>
    Sub Assigna()

        Try
            Dim resultat As Integer = gestorCursos.AssignaContingut(TextBoxIdContingut.Text, TextBoxIdCurs.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaContingutCurs_Assigna_OK, LabelInfo, Timer1)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaContingutCurs_Assigna_KO & ex.Message)
        End Try
        CarregaLlistaContingutsCurs()
    End Sub



    ''' <summary>
    ''' Desassigna un element  de la llista
    ''' </summary>
    ''' <remarks></remarks>
    ''' 
    Sub Desassigna()
        Try
            gestorCursos.EliminaAssignacioContingut(TextBoxIdContingut.Text, TextBoxIdCurs.Text)
            CarregaLlistaContingutsCurs()
            NetejaPantalla()
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaContingutCurs_DesAssigna_OK, LabelInfo, Timer1)

        Catch ex As Exception
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaContingutCurs_DesAssigna_OK, LabelInfo, Timer1)

        End Try

    End Sub

   

    Protected Sub GridViewCursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewCursos.SelectedIndexChanged
        SeleccionaCurs()
    End Sub
    Protected Sub GridViewCursos_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewCursos.PageIndexChanging
        GridViewCursos.PageIndex = e.NewPageIndex

        CarregaCursosTutor()


    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub ButtonAfegir_Click(sender As Object, e As EventArgs) Handles ButtonAfegir.Click
        If ComprovaDades() = 0 Then Assigna()

    End Sub

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        CarregaCursosTutor()
    End Sub

    Protected Sub ButtonCerca_Click(sender As Object, e As EventArgs) Handles ButtonCerca.Click
        CarregaResultatCercaContinguts()

    End Sub

    Protected Sub GridViewContinguts_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewContinguts.SelectedIndexChanged
        SeleccionaContingut()

    End Sub

    Protected Sub ButtonEliminar_Click(sender As Object, e As EventArgs) Handles ButtonEliminar.Click
        Desassigna()
    End Sub

    Protected Sub GridViewLlistaContinguts_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewLlistaContinguts.SelectedIndexChanged

    End Sub
    Protected Sub GridViewLlistaContinguts_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewLlistaContinguts.PageIndexChanging
        GridViewLlistaContinguts.PageIndex = e.NewPageIndex
        CarregaLlistaContingutsCurs()
    End Sub
    Protected Sub GridViewContinguts_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewContinguts.PageIndexChanging
        GridViewContinguts.PageIndex = e.NewPageIndex
        CarregaResultatCercaContinguts()
    End Sub
End Class