﻿Public Class GestioAjuda
    Inherits System.Web.UI.Page

    Dim gestor As GestorAjudaBD = New GestorAjudaBD()

    

    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'una nova FAQ
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxPregunta.Text = "" Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioAjuda_ComprovaDades_Pregunta, LabelInfo, Timer1)
            resultat = 1
        ElseIf TextBoxResposta.Text = "" Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioAjuda_ComprovaDades_Resposta, LabelInfo, Timer1)
            resultat = 1
        End If



        Return resultat

    End Function

    ''' <summary>
    '''  Carrega la llista de FAQ
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaFAQ()
        Try
            GridViewAjuda.DataSource = gestor.RetornaLlistaFAQ
            GridViewAjuda.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioAjuda_CarregaFAQ & ex.Message, vbExclamation)
        End Try

    End Sub

    ''' <summary>
    '''  Grava una nova FAQ
    ''' </summary>
    ''' <remarks></remarks>
    Sub NovaFAQ()

        Try
            Dim resultat As Integer = gestor.NovaFAQ(TextBoxPregunta.Text, TextBoxResposta.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioFAQ_NovaFAQ_OK, LabelInfo, Timer1)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioFAQ_NovaFAQ_KO & ex.Message)
        End Try
        CarregaFAQ()
    End Sub


    ''' <summary>
    ''' Neteja les dades mostrades
    ''' </summary>
    ''' <remarks></remarks>
    Sub NetejaPantalla()
        LabelId.Text = ""
        TextBoxResposta.Text = ""
        TextBoxPregunta.Text = ""
        
    End Sub

    ''' <summary>
    '''  Carrega les dades de la FAQ seleccionada
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaFAQ()
        Dim selectRow As GridViewRow = GridViewAjuda.SelectedRow
        'recuperem la FAQ
        For Each faq In gestor.RetornaFAQ(selectRow.Cells(1).Text)
            TextBoxPregunta.Text = faq.Pregunta
            TextBoxResposta.Text = faq.Resposta
            LabelId.Text = faq.Id
        Next


    End Sub

    ''' <summary>
    '''  Modifica les dades d'una noticia
    ''' </summary>
    ''' <remarks></remarks>
    Sub ModificaFAQ()
        Try
            Dim resultat As Integer = gestor.ModificaFAQ(LabelId.Text, TextBoxPregunta.Text, TextBoxResposta.Text)
            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioFAQ_ModificaFAQ_OK, LabelInfo, Timer1)
            CarregaFAQ()


        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioFAQ_ModificaFAQ_KO & ex.Message)
        End Try
    End Sub


    ''' <summary>
    ''' Elimina definitivament una FAQ
    ''' </summary>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    ''' 
    Function EliminaFAQ() As Integer
        Try
            gestor.EliminaFAQ(LabelId.Text)
            CarregaFAQ()
            NetejaPantalla()
            Return 0
        Catch ex As Exception

            Return 1
        End Try
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaFAQ()

        End If
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub
    Protected Sub ButtonGrava_Click(sender As Object, e As EventArgs) Handles ButtonGrava.Click
        If Page.IsValid Then
            If ComprovaDades() = 0 Then NovaFAQ()

        End If
    End Sub

    Protected Sub GridViewAjuda_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewAjuda.SelectedIndexChanged
        SeleccionaFAQ()

    End Sub
    Protected Sub ButtonElimina_Click(sender As Object, e As EventArgs) Handles ButtonElimina.Click
        If EliminaFAQ() = 0 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioFAQ_EliminaFAQ_OK, LabelInfo, Timer1)

        Else
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioFAQ_EliminaFAQ_KO, LabelInfo, Timer1)

        End If
    End Sub
    Protected Sub ButtonModifica_Click(sender As Object, e As EventArgs) Handles ButtonModifica.Click
        If ComprovaDades() = 0 Then ModificaFAQ()


    End Sub
    Protected Sub GridViewAjuda_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewAjuda.PageIndexChanging
        GridViewAjuda.PageIndex = e.NewPageIndex

        CarregaFAQ()

    End Sub
End Class