﻿Public Class GestioAlumnes
    Inherits System.Web.UI.Page
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()

    ''' <summary>
    ''' Carrega la llista de cursos tutoritzats per el tutor
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaCursos()
        Try
            GridViewCursos.DataSource = gestorCursos.RetornaLlistaCursosTutor(UsuariActiu.idUsuari)
            GridViewCursos.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaTest_CarregaCursos & ex.Message, vbExclamation)
        End Try
    End Sub

    ''' <summary>
    '''  Carrega les dades del curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaCurs()
        Dim selectRow As GridViewRow = GridViewCursos.SelectedRow
        Try
            For Each curs In gestorCursos.RetornaCurs(selectRow.Cells(1).Text)
                TextBoxIdCurs.Text = curs.Id
                TextBoxNomCurs.Text = curs.Nom

            Next
            CarregaLlistaAlumnesCurs()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioALumnes_SeleccionaCurs & ex.Message)
        End Try



    End Sub

    ''' <summary>
    '''  Carrega les dades del alumne seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaAlumne()
        Dim selectRow As GridViewRow = GridViewLlistaAlumnes.SelectedRow
        Try
            For Each alumne In gestorUsuaris.RetornaUsuari(selectRow.Cells(1).Text)
                'carreguem el id del alumne i curs a la sessio
                Session("idAlumne") = alumne.Id
                Session("idCurs") = TextBoxIdCurs.Text
            Next


        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioALumnes_SeleccionaCurs & ex.Message)
        End Try



    End Sub

    ''' <summary>
    ''' Carrega la llista dels alumnes assignats al curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaAlumnesCurs()
        Try
            Dim index As Integer = 1

            GridViewLlistaAlumnes.DataSource = gestorCursos.RetornaLlistaAlumnesCurs(TextBoxIdCurs.Text)
            GridViewLlistaAlumnes.DataBind()
            GridViewLlistaAlumnes.Caption = "Llista dels alumnes del curs " & TextBoxNomCurs.Text

            'afegim el nom del alumne

            For Each registre As GridViewRow In GridViewLlistaAlumnes.Rows
                Dim nom As TableCell = New TableCell()
                nom.Text = gestorUsuaris.ObteNomiCognomsUsuari(registre.Cells(1).Text)
                nom.BorderStyle = BorderStyle.Solid
                registre.Cells.Add(nom)
            Next

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioALumnes_CarregaLlistaAlumnesCurs & ex.Message, vbExclamation)

        End Try
    End Sub
   
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        CarregaCursos()

    End Sub

    Protected Sub GridViewCursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewCursos.SelectedIndexChanged
        SeleccionaCurs()
    End Sub

    Protected Sub GridViewLlistaAlumnes_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewLlistaAlumnes.SelectedIndexChanged
        SeleccionaAlumne()
        'redireccionem a la vista d'alumnes
        Response.Redirect("~/Pagines/VistaAlumne.aspx")
    End Sub
    Protected Sub GridViewCursos_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewCursos.PageIndexChanging
        GridViewCursos.PageIndex = e.NewPageIndex
        CarregaCursos()

    End Sub
    Protected Sub GridViewLlistaAlumnes_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewLlistaAlumnes.PageIndexChanging
        GridViewLlistaAlumnes.PageIndex = e.NewPageIndex
        CarregaLlistaAlumnesCurs()

    End Sub
End Class