﻿Public Class GestioCalendari
    Inherits System.Web.UI.Page
    Dim gestorCalendari As GestorCalendariBD = New GestorCalendariBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()



    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'un nou event
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxDescripcio.Text = "" Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioCalendari_ComprovaDades_Descripcio, LabelInfo, Timer1)
            resultat = 1

        End If



        Return resultat

    End Function


    ''' <summary>
    '''  Carrega la llista d'events
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaEvents()
        Try
            GridViewEvents.DataSource = gestorCalendari.RetornaLlistaEvents()
            GridViewEvents.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioCalendari_CarregaEvents & ex.Message, vbExclamation)
        End Try

    End Sub


    ''' <summary>
    '''  Grava un nou event
    ''' </summary>
    ''' <remarks></remarks>
    Sub NouEvent()

        Try
            Dim resultat As Integer = gestorCalendari.NouEvent(TextBoxDescripcio.Text & "_" & LabelCurs.Text, "", LabelCurs.Text, LabelData.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioCalendari_NouEvent_OK, LabelInfo, Timer1)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioCalendari_NouEvent_KO & ex.Message)
        End Try
        CarregaEvents()
    End Sub


    ''' <summary>
    ''' Neteja les dades mostrades
    ''' </summary>
    ''' <remarks></remarks>
    Sub NetejaPantalla()
        LabelId.Text = ""
        TextBoxDescripcio.Text = ""


    End Sub


    ''' <summary>
    '''  Carrega les dades de l'event seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaEvent()
        Dim selectRow As GridViewRow = GridViewEvents.SelectedRow
        'recuperem l'event
        For Each eventCalendari In gestorCalendari.RetornaLlistaEventsId(selectRow.Cells(1).Text)
            LabelId.Text = eventCalendari.IdEvent
            TextBoxDescripcio.Text = eventCalendari.Descripcio
            LabelCurs.Text = eventCalendari.Curs
            LabelData.Text = eventCalendari.Data
            CalendarAlta.SelectedDate = eventCalendari.Data
        Next


    End Sub

    ''' <summary>
    '''  Modifica les dades d'un event
    ''' </summary>
    ''' <remarks></remarks>
    Sub ModificaEvent()
        Try
            Dim resultat As Integer = gestorCalendari.ModificaEvent(LabelId.Text, TextBoxDescripcio.Text, "", LabelCurs.Text,
                                                                     LabelData.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioCalendari_ModificaEvent_OK, LabelInfo, Timer1)
            CarregaEvents()



        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioCalendari_ModificaEvent_KO & ex.Message)
        End Try
    End Sub


    ''' <summary>
    ''' Elimina definitivament un event
    ''' </summary>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    ''' 
    Function EliminaEvent() As Integer
        Try
            gestorCalendari.EliminaEvent(LabelId.Text)
            CarregaEvents()
            NetejaPantalla()
            Return 0
        Catch ex As Exception

            Return 1
        End Try
    End Function

    ''' <summary>
    ''' Carrega la llista de cursos al combo de cursos
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaCursos()
        'netegem el combo
        DropDownListCursos.Items.Clear()
        Dim primer As String = ""
        Try
            'Carreguem el combo

            Dim posPrimer As Integer = 1
            
            For Each curs In gestorCursos.RetornaLlistaCursos()

                DropDownListCursos.Items.Add(curs.Id)
                If posPrimer = 1 Then primer = curs.Id

                posPrimer = posPrimer + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_CarregaLlistaPerfils & ex.Message, vbExclamation)
        End Try
        LabelCurs.Text = primer



    End Sub



    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaEvents()
            CarregaLlistaCursos()



        End If
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub
    Protected Sub ButtonGrava_Click(sender As Object, e As EventArgs) Handles ButtonGrava.Click
        If Page.IsValid Then
            If ComprovaDades() = 0 Then NouEvent()

        End If
    End Sub


    Protected Sub GridViewEvents_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewEvents.SelectedIndexChanged
        SeleccionaEvent()

    End Sub
    Protected Sub ButtonElimina_Click(sender As Object, e As EventArgs) Handles ButtonElimina.Click
        If EliminaEvent() = 0 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioCalendari_EliminaEvent_OK, LabelInfo, Timer1)

        Else
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioCalendari_EliminaEvent_KO, LabelInfo, Timer1)

        End If
    End Sub
    Protected Sub ButtonModifica_Click(sender As Object, e As EventArgs) Handles ButtonModifica.Click
        If ComprovaDades() = 0 Then ModificaEvent()


    End Sub

    Protected Sub DropDownListCursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownListCursos.SelectedIndexChanged
        LabelCurs.Text = DropDownListCursos.Text

    End Sub
    Protected Sub GridViewEvents_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewEvents.PageIndexChanging
        GridViewEvents.PageIndex = e.NewPageIndex
        CarregaEvents()

    End Sub
   

    Protected Sub CalendarAlta_SelectionChanged(sender As Object, e As EventArgs) Handles CalendarAlta.SelectionChanged
        LabelData.Text = CalendarAlta.SelectedDate
    End Sub
End Class