﻿Public Class GestioContingutsCurs
    Inherits System.Web.UI.Page

    Dim gestor As GestorCursosBD = New GestorCursosBD()




    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'un nou recurs o contingut
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxNom.Text = "" Or Len(TextBoxNom.Text.Trim(" ")) > 50 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioContingutsCurs_ComprovaDades_Nom, LabelInfo, Timer1)
            resultat = 1
        ElseIf TextBoxDescripcio.Text = "" Or Len(TextBoxDescripcio.Text.Trim(" ")) > 50 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioContingutsCurs_ComprovaDades_Descripcio, LabelInfo, Timer1)
            resultat = 1
        ElseIf TextBoxTipus.Text = "" Or Len(TextBoxTipus.Text.Trim(" ")) > 10 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioContingutsCurs_ComprovaDades_Tipus, LabelInfo, Timer1)
            resultat = 1

        End If



        Return resultat

    End Function

    ''' <summary>
    ''' Carrega la llista de continguts/recursos
    ''' </summary>
    ''' <param name="opcio">RadioButton seleccionat</param>
    ''' <remarks></remarks>
    Sub CarregaContinguts(ByVal opcio As RadioButton)
        Try
            If opcio.ID = "RadioButtonContingut" Then
                GridViewContinguts.DataSource = gestor.RetornaLlistaContinguts()
            Else
                GridViewContinguts.DataSource = gestor.RetornaLlistaRecursos()
            End If


            GridViewContinguts.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioContinguts_Carrega & ex.Message, vbExclamation)
        End Try

    End Sub

    ''' <summary>
    '''  Grava un nou contingut/recurs
    ''' </summary>
    ''' <param name="opcio">RadioButton seleccionat</param>
    ''' <remarks></remarks>
    Sub NouContingut(ByVal opcio As RadioButton)

        Try
            Dim resultat As Integer
            If RadioButtonContingut.Checked = True Then
                resultat = gestor.NouContingut(TextBoxNom.Text, TextBoxDescripcio.Text, TextBoxTipus.Text, "~/ContingutCursos/" & TextBoxNom.Text.Trim(" ") & "." & TextBoxTipus.Text)
                CarregaContinguts(RadioButtonContingut)
            Else
                resultat = gestor.NouRecurs(TextBoxNom.Text, TextBoxDescripcio.Text, TextBoxTipus.Text, "~/RecursosCursos/" & TextBoxNom.Text.Trim(" ") & "." & TextBoxTipus.Text)
                CarregaContinguts(RadioButtonRecurs)
            End If
          
            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioContinguts_NouContingut_OK, LabelInfo, Timer1)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioContinguts_NouContingut_KO & ex.Message)
        End Try
      
    End Sub


    ''' <summary>
    ''' Neteja les dades mostrades
    ''' </summary>
    ''' <remarks></remarks>
    Sub NetejaPantalla()
        LabelId.Text = ""
        TextBoxNom.Text = ""
        TextBoxDescripcio.Text = ""
        TextBoxTipus.Text = ""
    End Sub

    ''' <summary>
    '''  Carrega les dades de l'element seleccionat
    ''' </summary>
    ''' <param name="opcio">RadioButton seleccionat</param>
    ''' <remarks></remarks>
    Sub Selecciona(ByVal opcio As RadioButton)
        Dim selectRow As GridViewRow = GridViewContinguts.SelectedRow
        'recuperem 
        If RadioButtonContingut.Checked = True Then
            For Each contingut In gestor.RetornaContingut(selectRow.Cells(1).Text)
                LabelId.Text = contingut.Id
                TextBoxNom.Text = contingut.Nom
                TextBoxDescripcio.Text = contingut.Descripcio
                TextBoxTipus.Text = contingut.Tipus
            Next
            
        Else
            ''RECURS
            For Each recurs In gestor.RetornaRecurs(selectRow.Cells(1).Text)
                LabelId.Text = recurs.Id
                TextBoxNom.Text = recurs.Nom
                TextBoxDescripcio.Text = recurs.Descripcio
                TextBoxTipus.Text = recurs.Tipus
            Next
        End If
        


    End Sub

    ''' <summary>
    '''  Modifica les dades d'un ELEMENT
    ''' </summary>
    ''' <param name="opcio">RadioButton seleccionat</param>
    ''' <remarks></remarks>
    Sub Modifica(ByVal opcio As RadioButton)
        Try
            Dim resultat As Integer
            If RadioButtonContingut.Checked = True Then
                resultat = gestor.ModificaContingut(LabelId.Text, TextBoxNom.Text, TextBoxDescripcio.Text, TextBoxTipus.Text, "~/App_GlobalResources/ContingutCursos/" & TextBoxNom.Text.Trim(" ") & "." & TextBoxTipus.Text)
                CarregaContinguts(RadioButtonContingut)
            Else
                resultat = gestor.ModificaRecurs(LabelId.Text, TextBoxNom.Text, TextBoxDescripcio.Text, TextBoxTipus.Text, "~/App_GlobalResources/RecursosCursos/" & TextBoxNom.Text.Trim(" ") & "." & TextBoxTipus.Text)

                CarregaContinguts(RadioButtonRecurs)
            End If
            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioContinguts_Modifica_OK, LabelInfo, Timer1)

        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioContinguts_Modifica_KO & ex.Message)
        End Try
    End Sub


    ''' <summary>
    ''' Elimina definitivament un element
    ''' </summary>
    ''' <param name="opcio">RadioButton seleccionat</param>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    ''' 
    Function Elimina(ByVal opcio As RadioButton) As Integer
        Try
            If RadioButtonContingut.Checked = True Then
                gestor.EliminaContingut(LabelId.Text)
                CarregaContinguts(RadioButtonContingut)

            Else
                gestor.EliminaRecurs(LabelId.Text)
                CarregaContinguts(RadioButtonRecurs)
            End If

            NetejaPantalla()
            Return 0
        Catch ex As Exception

            Return 1
        End Try
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaContinguts(RadioButtonContingut)

        End If
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub
    Protected Sub ButtonGrava_Click(sender As Object, e As EventArgs) Handles ButtonGrava.Click
        If Page.IsValid Then
            If ComprovaDades() = 0 Then
                If RadioButtonContingut.Checked = True Then
                    NouContingut(RadioButtonContingut)
                Else
                    NouContingut(RadioButtonRecurs)
                End If
            End If

        End If
    End Sub

    Protected Sub GridViewContinguts_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewContinguts.SelectedIndexChanged
        If RadioButtonContingut.Checked = True Then
            Selecciona(RadioButtonContingut)
        Else
            Selecciona(RadioButtonRecurs)
        End If

    End Sub
    Protected Sub GridViewContinguts_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewContinguts.PageIndexChanging
        GridViewContinguts.PageIndex = e.NewPageIndex
        If RadioButtonContingut.Checked = True Then
            CarregaContinguts(RadioButtonContingut)
        Else
            CarregaContinguts(RadioButtonRecurs)
        End If

    End Sub
    Protected Sub ButtonElimina_Click(sender As Object, e As EventArgs) Handles ButtonElimina.Click
        Dim resultat As Integer = 0
        If RadioButtonContingut.Checked = True Then
            resultat = Elimina(RadioButtonContingut)
        Else
            resultat = Elimina(RadioButtonRecurs)
        End If

        If resultat = 0 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioContinguts_Elimina_OK, LabelInfo, Timer1)

        Else
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioContinguts_Elimina_KO, LabelInfo, Timer1)

        End If
    End Sub
    Protected Sub ButtonModifica_Click(sender As Object, e As EventArgs) Handles ButtonModifica.Click
        If ComprovaDades() = 0 Then
            If RadioButtonContingut.Checked = True Then
                Modifica(RadioButtonContingut)
            Else
                Modifica(RadioButtonRecurs)
            End If
        End If


    End Sub

    Protected Sub RadioButtonContingut_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButtonContingut.CheckedChanged
        CarregaContinguts(RadioButtonContingut)

    End Sub

    Protected Sub RadioButtonRecurs_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButtonRecurs.CheckedChanged
        CarregaContinguts(RadioButtonRecurs)
    End Sub
End Class