﻿Public Class GestioNoticies
    Inherits System.Web.UI.Page
    Dim gestorNoticies As GestorNoticiesBD = New GestorNoticiesBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()

    ''' <summary>
    '''  Carrega la llista de noticies
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaNoticies(ByVal camp As String)
        Try
            If camp.Contains("Tot") Then
                GridViewNoticies.DataSource = gestorNoticies.RetornaLlistaNoticies()
            End If


            GridViewNoticies.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioNoticies_carregaNoticies & ex.Message, vbExclamation)
        End Try

    End Sub

    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'una nova notícia
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxDescripcio.Text = "" Then
            MsgBox(Resources.Missatges.Info_PaginaGestioNoticies_ComprovaDades_Descripcio, vbInformation)
            resultat = 1
        ElseIf TextBoxDescripcio.Text = "" Then
            MsgBox(Resources.Missatges.Info_PaginaGestioNoticies_ComprovaDades_Enllac, vbInformation)
            resultat = 1
        End If



        Return resultat

    End Function

    ''' <summary>
    ''' Carrega la llista de perfils al combo de perfils
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaPerfils()
        'netegem el combo
        DropDownListPerfils.Items.Clear()
        Dim primer As String = ""
        Try
            'Carreguem el combo

            Dim posPrimer As Integer = 1
            For Each perfil In gestorUsuaris.RetornaPerfils
                DropDownListPerfils.Items.Add(perfil.Descripcio)
                If posPrimer = 1 Then primer = perfil.Descripcio
                posPrimer = posPrimer + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_CarregaLlistaPerfils & ex.Message, vbExclamation)
        End Try
        LabelPerfil.Text = primer



    End Sub

   

    ''' <summary>
    '''  Grava una nova noticia
    ''' </summary>
    ''' <remarks></remarks>
    Sub NovaNoticia()

        Try
            Dim resultat As Integer = gestorNoticies.NovaNoticia(TextBoxDescripcio.Text, TextBoxEnllac.Text, LabelPerfil.Text, LabelAlta.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioNoticies_NovaNoticia_OK, LabelInfo, Timer1)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioNoticies_NovaNoticia_KO & ex.Message)
        End Try
        CarregaNoticies("Tot")
    End Sub


    ''' <summary>
    '''  Carrega les dades de la noticia seleccionada
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaNoticia()
        Dim selectRow As GridViewRow = GridViewNoticies.SelectedRow
        Try
            For Each noticia In gestorNoticies.RetornaNoticia(selectRow.Cells(1).Text)
                LabelId.Text = noticia.Id
                TextBoxDescripcio.Text = noticia.Contingut
                TextBoxEnllac.Text = noticia.TextEnllac
                LabelAlta.Text = noticia.DataAlta
                CalendarDataAlta.SelectedDate = noticia.DataAlta
                LabelPerfil.Text = noticia.Perfil
            Next

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioNoticies_carregaNoticies & ex.Message, vbExclamation)
        End Try
        
        

    End Sub

    ''' <summary>
    '''  Modifica les dades d'una noticia
    ''' </summary>
    ''' <remarks></remarks>
    Sub ModificaNoticia()
        Try
            Dim resultat As Integer = gestorNoticies.ModificaNoticia(LabelId.Text, TextBoxDescripcio.Text, TextBoxEnllac.Text, LabelAlta.Text, LabelPerfil.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioNoticia_ModificaNoticia_OK, LabelInfo, Timer1)
            CarregaNoticies("Tot")

        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioNoticia_ModificaNoticia_KO & ex.Message)
        End Try
    End Sub

    ''' <summary>
    ''' Neteja les dades mostrades
    ''' </summary>
    ''' <remarks></remarks>
    Sub NetejaPantalla()
        LabelId.Text = ""
        TextBoxDescripcio.Text = ""
        TextBoxEnllac.Text = ""
        LabelAlta.Text = ""
        CalendarDataAlta.SelectedDate = Today
        LabelPerfil.Text = DropDownListPerfils.Text
    End Sub

    ''' <summary>
    ''' Elimina definitivament una noticia
    ''' </summary>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    ''' 
    Function EliminaNoticia() As Integer

        Try
            gestorNoticies.EliminaNoticia(LabelId.Text)
            CarregaNoticies("Tot")
            NetejaPantalla()

            Return 0
        Catch ex As Exception
            Return 1
        End Try
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaLlistaPerfils()
            LabelAlta.Text = Today.ToString
            CarregaNoticies("Tot")
        End If
    End Sub



    Protected Sub TextBox2_TextChanged(sender As Object, e As EventArgs) Handles TextBoxDescripcio.TextChanged

    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub CalendarDataAlta_SelectionChanged(sender As Object, e As EventArgs) Handles CalendarDataAlta.SelectionChanged
        LabelAlta.Text = CalendarDataAlta.SelectedDate
    End Sub

    Protected Sub ButtonGravar_Click(sender As Object, e As EventArgs) Handles ButtonGravar.Click
        If Page.IsValid Then
            If ComprovaDades() = 0 Then NovaNoticia()
        End If
    End Sub

    Protected Sub DropDownListPerfils_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownListPerfils.SelectedIndexChanged
        LabelPerfil.Text = DropDownListPerfils.Text 'mostrem el perfil seleccionat
    End Sub

    Protected Sub GridViewNoticies_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewNoticies.SelectedIndexChanged
        SeleccionaNoticia()
    End Sub
    Protected Sub GridViewNoticies_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewNoticies.PageIndexChanging
        GridViewNoticies.PageIndex = e.NewPageIndex
        
        CarregaNoticies("Tot")
    End Sub
   
    Protected Sub ButtonElimina_Click(sender As Object, e As EventArgs) Handles ButtonElimina.Click
        If EliminaNoticia() = 0 Then
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioNoticies_EliminaNoticia_OK, LabelInfo, Timer1)

        Else
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioNoticies_EliminaNoticia_KO, LabelInfo, Timer1)

        End If
    End Sub

    Protected Sub ButtonModifica_Click(sender As Object, e As EventArgs) Handles ButtonModifica.Click
        If ComprovaDades() = 0 Then ModificaNoticia()

    End Sub
End Class