﻿Public Class GestioTest
    Inherits System.Web.UI.Page
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()

    'FUNCIONS COMUNES

    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'un nou test,pregunta o resposta
    ''' </summary>
    ''' <param name="tipus" ></param>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades(tipus As String) As Integer
        Dim resultat As Integer = 0

        'Test
        If tipus.Contains("test") Then
            If TextBoxNomTest.Text = "" Then
                MsgBox(Resources.Missatges.Info_PaginaGestioTest_ComprovaDades_NomTest, vbInformation)
                resultat = 1
            End If
        End If

        'Preguntes/respostes test
        If tipus.Contains("contingutTest") Then
            'Preguntes/respostes test
            If TextBoxContingut.Text = "" Then
                MsgBox(Resources.Missatges.Info_PaginaGestioTest_ComprovaDades_Contingut, vbInformation)
                resultat = 1
            ElseIf TextBoxValorCorrecte.Text = "" Or TextBoxValorIncorrecte.Text = "" Then
                MsgBox(Resources.Missatges.Info_PaginaGestioTest_ComprovaDades_Valor, vbInformation)
                resultat = 1
            End If
        End If



            Return resultat

    End Function


    'TEST
    ''' <summary>
    '''  Carrega la llista de test
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaTest()
        Try

            GridViewtest.DataSource = gestorCursos.RetornaLlistaTest()
            GridViewtest.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_CarregaTest & ex.Message, vbExclamation)
        End Try

    End Sub

    ''' <summary>
    '''  Grava una NOU TEST
    ''' </summary>
    ''' <remarks></remarks>
    Sub NouTest()

        Try
            Dim resultat As Integer = gestorCursos.NouTest(TextBoxNomTest.Text, CalendarDataAltaTest.SelectedDate)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioTest_NouTest_OK, LabelInfo, Timer1)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioTest_NouTest_KO & ex.Message)
        End Try
        CarregaTest()

    End Sub

    ''' <summary>
    ''' Cerca el test amb nom similar a TextBoxNomTest.Text
    ''' </summary>
    ''' <remarks></remarks>
    Sub CercaTest()
        Try

            GridViewtest.DataSource = gestorCursos.RetornaTestNom(TextBoxNomTest.Text)
            GridViewtest.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_CarregaTest & ex.Message, vbExclamation)

        End Try
    End Sub

    ''' <summary>
    '''  Carrega les dades del test seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaTest()
        Dim selectRow As GridViewRow = GridViewtest.SelectedRow
        Try
            For Each test In gestorCursos.RetornaTestId(selectRow.Cells(1).Text)
                LabelIdTest.Text = test.IdTest
                TextBoxNomTest.Text = test.Nom
                CalendarDataAltaTest.SelectedDate = test.DataAlta

            Next
            'Carreguem la llista de preguntes del test
            CarregaPreguntesTest(selectRow.Cells(1).Text)
            'mostrem l'apartat de preguntes i respostes
            Panel5.Visible = True

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_SeleccionaTest & ex.Message, vbExclamation)
        End Try



    End Sub


    ''' <summary>
    '''  Modifica les dades d'un test
    ''' </summary>
    ''' <remarks></remarks>
    Sub ModificaTest()
        Try
            Dim resultat As Integer = gestorCursos.ModificaTest(LabelIdTest.Text, TextBoxNomTest.Text, CalendarDataAltaTest.SelectedDate)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioTest_ModificaTest_OK, LabelInfo, Timer1)
            CarregaTest()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioTest_ModificaTest_KO & ex.Message)
        End Try
    End Sub


    ''' <summary>
    ''' Elimina definitivament un test
    ''' </summary>
    ''' <returns>0 si correcte,1 altrament</returns>
    ''' <remarks></remarks>
    ''' 
    Function EliminaTest() As Integer

        Try
            gestorCursos.EliminaTest(LabelIdTest.Text)
            CarregaTest()

            Return 0
        Catch ex As Exception
            Return 1
        End Try
    End Function

    ' PREGUNTES I RESPOSTES

    ''' <summary>
    ''' Mostra l'apariència de pregunta
    ''' </summary>
    ''' <remarks></remarks>
    Sub EsPregunta()
        LabelValorCorrecte.Visible = True
        LabelValorIncorrecte.Visible = True
        TextBoxValorCorrecte.Visible = True
        TextBoxValorIncorrecte.Visible = True
        CheckBoxRespostaCorrecte.Visible = False
        LabelPreguntaSeleccionada.Visible = False

    End Sub

    ''' <summary>
    ''' Mostra l'apariència de resposta
    ''' </summary>
    ''' <remarks></remarks>
    Sub EsResposta()
        LabelValorCorrecte.Visible = False
        LabelValorIncorrecte.Visible = False
        TextBoxValorCorrecte.Visible = False
        TextBoxValorIncorrecte.Visible = False
        CheckBoxRespostaCorrecte.Visible = True

        LabelPreguntaSeleccionada.Visible = True
    End Sub

    ''' <summary>
    '''  Carrega la llista de PREGUNTES DEL TEST
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaPreguntesTest(ByVal IdTest As Integer)
        Try

            GridViewPreguntesTest.DataSource = gestorCursos.RetornaLlistaPreguntesTest(IdTest)
            GridViewPreguntesTest.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_CarregaTest & ex.Message, vbExclamation)
        End Try

    End Sub

    ''' <summary>
    '''  Carrega la llista de respostes de la pregunta
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaRespostesPregunta(ByVal idPregunta As Integer)
        Try

            GridViewRespostes.DataSource = gestorCursos.RetornaLlistaRespostesPregunta(idPregunta)
            GridViewRespostes.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_CarregaTest & ex.Message, vbExclamation)
        End Try

    End Sub


    ''' <summary>
    '''  Grava una nova pregunta
    ''' </summary>
    ''' <remarks></remarks>
    Sub NovaPregunta()

        Try
            Dim resultat As Integer = gestorCursos.NovaPregunta(LabelIdTest.Text, TextBoxContingut.Text, TextBoxValorCorrecte.Text, TextBoxValorIncorrecte.Text)

            If resultat = 0 Then
                Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioTest_NovaPregunta_OK, LabelInfo, Timer1)
                CarregaPreguntesTest(LabelIdTest.Text)
            End If

        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioTest_NovaPregunta_KO & ex.Message)
        End Try
        CarregaTest()

    End Sub

    ''' <summary>
    '''  Modifica les dades d'una pregunta
    ''' </summary>
    ''' <remarks></remarks>
    Sub ModificaPregunta()
        Try
            Dim resultat As Integer = gestorCursos.ModificaPregunta(LabelIdPregunta.Text, TextBoxContingut.Text, TextBoxValorCorrecte.Text, TextBoxValorIncorrecte.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioTest_ModificaPregunta_OK, LabelInfo, Timer1)


        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioTest_ModificaPregunta_KO & ex.Message)
        End Try
    End Sub


    ''' <summary>
    '''  Grava una nova resposta
    ''' </summary>
    ''' <remarks></remarks>
    Sub NovaResposta()
        Dim esCorrecte As Integer = 0
        If CheckBoxRespostaCorrecte.Checked Then esCorrecte = 1

        Try
            Dim resultat As Integer = gestorCursos.NovaResposta(LabelIdPregunta.Text, TextBoxContingut.Text, esCorrecte)
            If resultat = 0 Then
                Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioTest_NovaResposta_OK, LabelInfo, Timer1)
                CarregaRespostesPregunta(LabelIdPregunta.Text)
            End If

        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioTest_NovaResposta_KO & ex.Message)
        End Try
        CarregaTest()

    End Sub

    ''' <summary>
    '''  Modifica les dades d'una resposta
    ''' </summary>
    ''' <remarks></remarks>
    Sub ModificaResposta()
        Dim esCorrecte As Integer = 0
        If CheckBoxRespostaCorrecte.Checked Then esCorrecte = 1
        Try
            Dim resultat As Integer = gestorCursos.ModificaResposta(LabelIdResposta.Text, TextBoxContingut.Text, esCorrecte)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaGestioTest_ModificaResposta_OK, LabelInfo, Timer1)


        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaGestioTest_ModificaResposta_KO & ex.Message)
        End Try
    End Sub

    ''' <summary>
    '''  Carrega les dades de la pregunta seleccionada
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaPregunta()
        Dim selectRow As GridViewRow = GridViewPreguntesTest.SelectedRow
        Try
            EsPregunta()
            RadioButtonPregunta.Checked = True
            For Each pregunta In gestorCursos.RetornaPreguntaId(selectRow.Cells(2).Text)
                LabelIdPregunta.Text = pregunta.Id
                TextBoxContingut.Text = pregunta.Text
                TextBoxValorCorrecte.Text = pregunta.PuntsRespostaCorrecte
                TextBoxValorIncorrecte.Text = pregunta.PuntsRespostaIncorrecte
                LabelPreguntaSeleccionada.Text = "Pregunta :" & pregunta.Text
            Next
            'Carreguem la llista de respostes  de la pregunta
            CarregaRespostesPregunta(selectRow.Cells(2).Text)

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_SeleccionaPregunta & ex.Message, vbExclamation)
        End Try



    End Sub

    ''' <summary>
    '''  Carrega les dades de la resposta seleccionada
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaResposta()
        Dim selectRow As GridViewRow = GridViewRespostes.SelectedRow
        Try
            EsResposta()
            RadioButtonResposta.Checked = True
            For Each resposta In gestorCursos.RetornaRespostaId(selectRow.Cells(3).Text)
                LabelIdResposta.Text = resposta.Id
                TextBoxContingut.Text = resposta.Text
                If resposta.Correcte = 0 Then
                    CheckBoxRespostaCorrecte.Checked = False
                Else
                    CheckBoxRespostaCorrecte.Checked = True
                End If

            Next


        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_SeleccionaResposta & ex.Message, vbExclamation)
        End Try



    End Sub

    ''' <summary>
    ''' Elimina la resposta seleccionada
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function EliminaResposta() As Integer

        Try
            gestorCursos.EliminaResposta(LabelIdResposta.Text)
            CarregaRespostesPregunta(LabelIdPregunta.Text)

            Return 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_EliminaResposta & ex.Message, vbExclamation)

            Return 1
        End Try
    End Function

    ''' <summary>
    ''' Elimna la pregunta seleccionada y la llista de les respostes associades
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function EliminaPregunta() As Integer

        Try
            gestorCursos.EliminaPregunta(LabelIdPregunta.Text)
            CarregaPreguntesTest(LabelIdTest.Text)
            CarregaRespostesPregunta(LabelIdPregunta.Text)
            Return 0
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaGestioTest_EliminaPregunta & ex.Message, vbExclamation)

            Return 1
        End Try
    End Function
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        CarregaTest()
       
    End Sub

    Protected Sub ButtonTornar_Click(sender As Object, e As EventArgs) Handles ButtonTornar.Click
        Response.Redirect("~/Pagines/Test.aspx")
    End Sub
    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub ButtonGravaTest_Click(sender As Object, e As EventArgs) Handles ButtonGravaTest.Click
        If ComprovaDades("test") = 0 Then NouTest()
    End Sub

    Protected Sub GridViewtest_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewtest.SelectedIndexChanged
        SeleccionaTest()

    End Sub
    Protected Sub GridViewtest_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewtest.PageIndexChanging
        GridViewtest.PageIndex = e.NewPageIndex
        CercaTest()
    End Sub

    
    Protected Sub ButtonModificaTest_Click(sender As Object, e As EventArgs) Handles ButtonModificaTest.Click
        If ComprovaDades("test") = 0 Then ModificaTest()
    End Sub

    Protected Sub ButtonCercaTest_Click(sender As Object, e As EventArgs) Handles ButtonCercaTest.Click
        CercaTest()
    End Sub

   
    Protected Sub ButtonAfegirP_R_Click(sender As Object, e As EventArgs) Handles ButtonAfegirP_R.Click
        If RadioButtonPregunta.Checked Then
            'preguntes
            NovaPregunta()
        Else
            'respostes
            NovaResposta()

        End If
    End Sub

    Protected Sub RadioButtonPregunta_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButtonPregunta.CheckedChanged
        EsPregunta()

        TextBoxContingut.Text = ""
    End Sub

    Protected Sub RadioButtonResposta_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButtonResposta.CheckedChanged
        EsResposta()

        TextBoxContingut.Text = ""
    End Sub

    Protected Sub GridViewPreguntesTest_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewPreguntesTest.SelectedIndexChanged
        SeleccionaPregunta()
    End Sub
    Protected Sub GridViewPreguntesTest_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewPreguntesTest.PageIndexChanging
        GridViewPreguntesTest.PageIndex = e.NewPageIndex
        CarregaPreguntesTest(LabelIdTest.Text)
    End Sub

    Protected Sub GridViewRespostes_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewRespostes.SelectedIndexChanged
        SeleccionaResposta()

    End Sub
    Protected Sub GridViewRespostes_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewRespostes.PageIndexChanging
        GridViewRespostes.PageIndex = e.NewPageIndex
        CarregaRespostesPregunta(LabelIdPregunta.Text)
    End Sub

    Protected Sub ButtonModificaP_R_Click(sender As Object, e As EventArgs) Handles ButtonModificaP_R.Click
        If RadioButtonPregunta.Checked Then
            'preguntes
            If ComprovaDades("contingutTest") = 0 Then ModificaPregunta()
        Else
            'respostes
            If ComprovaDades("contingutTest") = 0 Then ModificaResposta()

        End If
    End Sub

    Protected Sub ButtonEsborraP_R_Click(sender As Object, e As EventArgs) Handles ButtonEsborraP_R.Click
        If RadioButtonPregunta.Checked Then
            'preguntes
            If EliminaPregunta() = 0 Then
                Utils.MostrarInformacioAccio(Resources.Missatges.Error_PaginaGestioTest_EliminaPregunta_OK, LabelInfo, Timer1)
            Else
                Utils.MostrarInformacioAccio(Resources.Missatges.Error_PaginaGestioTest_EliminaPregunta_KO, LabelInfo, Timer1)
            End If
        Else
            'respostes
            If EliminaResposta() = 0 Then
                Utils.MostrarInformacioAccio(Resources.Missatges.Error_PaginaGestioTest_EliminaResposta_OK, LabelInfo, Timer1)
            Else
                Utils.MostrarInformacioAccio(Resources.Missatges.Error_PaginaGestioTest_EliminaResposta_OK, LabelInfo, Timer1)
            End If

        End If
    End Sub
End Class