﻿Public Class ModificaCursos
    Inherits System.Web.UI.Page
    Dim gestor As GestorCursosBD = New GestorCursosBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()



    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'un nou curs
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxIdCurs.Text = "" Or Len(TextBoxIdCurs.Text) > 15 Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_Id, vbInformation)
            resultat = 1
        End If
        If TextBoxNomCurs.Text = "" Or Len(TextBoxNomCurs.Text) > 30 Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_Nom, vbInformation)
            resultat = 1
        End If
        If TextBoxDatInici.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_DataInici, vbInformation)
            resultat = 1
        End If
        If TextBoxTutor.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_Tutor, vbInformation)
            resultat = 1
        End If
        If TextBoxDatFinal.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_DataFi, vbInformation)
            resultat = 1
        End If
        If CDate(TextBoxDatFinal.Text) < CDate(TextBoxDatInici.Text) Then
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_ComprovaDades_ConsistenciaDatas, vbInformation)
            resultat = 1


        End If
        Return resultat

    End Function

    ''' <summary>
    ''' Carrega la llista de tutors
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaTutors()
        GridViewTutors.DataSource = gestorUsuaris.RetornaTutors
        GridViewTutors.DataBind()

    End Sub

    ''' <summary>
    ''' Carrega les dades d'un tutor
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaTutor()
        Dim selectRow As GridViewRow = GridViewTutors.SelectedRow
        'recuperem la FAQ
        Try
            For Each tutor In gestorUsuaris.RetornaUsuari(selectRow.Cells(1).Text)
                LabelIdTutor.Text = tutor.Id
                TextBoxTutor.Text = tutor.Nom & " " & tutor.Cognoms
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaCurs_SeleccionaTutor & ex.Message, vbExclamation)

        End Try

    End Sub

    ''' <summary>
    ''' Retorna els cursos cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCerca()
        Try
            If DropDownListCerca.Text = "Id" Then
                GridViewResultatCerca.DataSource = gestor.RetornaCurs(TextBoxCerca.Text)

            ElseIf DropDownListCerca.Text = "Nom" Then
                GridViewResultatCerca.DataSource = gestor.RetornaCursosNom(TextBoxCerca.Text)

            End If
            GridViewResultatCerca.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaBaixaCursos_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    '''  Carrega les dades del curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaCurs()
        Dim selectRow As GridViewRow = GridViewResultatCerca.SelectedRow
        Try
            For Each curs In gestor.RetornaCurs(selectRow.Cells(1).Text)
                TextBoxIdCurs.Text = curs.Id
                TextBoxDatFinal.Text = curs.DataFi
                TextBoxDatInici.Text = curs.DataInici
                TextBoxDescCurs.Text = curs.Descripcio
                TextBoxNomCurs.Text = curs.Nom
                For Each tutor In gestorUsuaris.RetornaUsuari(curs.TutorPrincipal)
                    TextBoxTutor.Text = tutor.Nom.Trim(" ") & " " & tutor.Cognoms
                    LabelIdTutor.Text = tutor.Id
                Next
                

            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaBaixaCursos_CarregaResultatCerca & ex.Message)
        End Try
        'el id del curs no es pot modificar
        TextBoxIdCurs.Enabled = False
        TextBoxIdCurs.BackColor = Drawing.Color.LightGray
        ButtonModifica.Enabled = True

    End Sub


    ''' <summary>
    ''' Modifica les dades d'un curs
    ''' </summary>
    ''' <remarks></remarks>
    Sub ModificaCurs()
        'Comprovem compatibilitats 


        'preparem el missatge de comprovació
        Dim checkAlta As String = "Comprovem dades nou curs:" & vbCrLf & vbCrLf _
                                 & "Id :" & TextBoxIdCurs.Text & vbCrLf _
                                 & "Nom :" & TextBoxNomCurs.Text & vbCrLf _
                                 & "Descripció :" & TextBoxDescCurs.Text & vbCrLf _
                                 & "Tutor :" & TextBoxTutor.Text & vbCrLf _
                                 & "Data inici :" & TextBoxDatInici.Text & vbCrLf _
                                 & "Data fi :" & TextBoxDatFinal.Text & vbCrLf & vbCrLf _
                                 & "Són correctes ? "

        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel Or MsgBoxStyle.Information
        Dim resposta As MsgBoxResult

        'generem el missatge de comprovació
        resposta = MsgBox(checkAlta, style)

        'si es ok endavant
        If resposta = MsgBoxResult.Ok Then
            Try
                Dim resultat As Integer = gestor.ModificaCurs(TextBoxIdCurs.Text, TextBoxNomCurs.Text, TextBoxDescCurs.Text, LabelIdTutor.Text, TextBoxDatInici.Text, TextBoxDatFinal.Text)

                If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaModificaCurs_ModificaCurs_OK, LabelInfo, Timer1)
            Catch ex As Exception
                MsgBox(Resources.Missatges.Info_PaginaModificaCurs_ModificaCurs_KO & ex.Message)
            End Try
        Else ' si no es correcte cancelem l'alta
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAltaCurs_NouCurs_CancelatPerUser, LabelInfo, Timer1)
        End If



    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaLlistaTutors()

        End If
    End Sub
    Protected Sub ButtonCercaCamp_Click(sender As Object, e As EventArgs) Handles ButtonCercaCamp.Click

        CarregaResultatCerca()
    End Sub
    Protected Sub GridViewResultatCerca_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewResultatCerca.SelectedIndexChanged
        SeleccionaCurs()
    End Sub
    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub ButtonNovaCerca_Click(sender As Object, e As EventArgs) Handles ButtonNovaCerca.Click
        'el id del curs no es pot modificar
        TextBoxIdCurs.Enabled = True
        TextBoxIdCurs.BackColor = Drawing.Color.White
        ButtonModifica.Enabled = False
    End Sub

    Protected Sub ButtonModifica_Click(sender As Object, e As EventArgs) Handles ButtonModifica.Click
        If ComprovaDades() = 0 Then ModificaCurs()

    End Sub

    Protected Sub GridViewTutors_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewTutors.SelectedIndexChanged
        SeleccionaTutor()
    End Sub
    Protected Sub GridViewTutors_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewTutors.PageIndexChanging
        GridViewTutors.PageIndex = e.NewPageIndex
        CarregaLlistaTutors()
    End Sub
End Class