﻿Public Class ModificaUsuari
    Inherits System.Web.UI.Page
    Dim gestor As GestorUsuarisBD = New GestorUsuarisBD()


    ''' <summary>
    ''' Retorna els usuaris cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCerca()
        Try
            If DropDownListCerca.Text = "Id" Then
                GridViewResultatCerca.DataSource = gestor.RetornaUsuari(TextBoxId.Text)

            ElseIf DropDownListCerca.Text = "Cognoms" Then
                GridViewResultatCerca.DataSource = gestor.RetornaUsuariCognoms(TextBoxCognoms.Text)

            End If
            GridViewResultatCerca.DataBind()
            CheckBoxActiu.Visible = False 'ocultem l'opció d'activació

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaConsultaUsuari_CarregaResultatCerca & ex.Message)
        End Try
        ButtonModifica.Visible = False

    End Sub


    ''' <summary>
    ''' Carrega la llista de perfils al combo de perfils
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaPerfils()
        'netegem el combo
        DropDownListPerfils.Items.Clear()
        Dim primer As String = ""
        Try
            'Carreguem el combo

            Dim posPrimer As Integer = 1
            For Each perfil In gestor.RetornaPerfils
                DropDownListPerfils.Items.Add(perfil.Descripcio)
                If posPrimer = 1 Then primer = perfil.Descripcio
                posPrimer = posPrimer + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_CarregaLlistaPerfils & ex.Message, vbExclamation)
        End Try
        LabelPerfil.Text = primer



    End Sub

    ''' <summary>
    '''  Carrega les dades del usuari seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaUsuari()

        Dim selectRow As GridViewRow = GridViewResultatCerca.SelectedRow
        For Each usuariSeleccionat In gestor.RetornaUsuari(selectRow.Cells(1).Text)
            TextBoxId.Text = usuariSeleccionat.Id
            TextBoxNom.Text = usuariSeleccionat.Nom
            TextBoxCognoms.Text = usuariSeleccionat.Cognoms
            TextBoxAdreca.Text = usuariSeleccionat.Direccio
            TextBoxTelefon.Text = usuariSeleccionat.Telefon
            TextBoxEmail.Text = usuariSeleccionat.Email
            LabelDataAlta.Text = usuariSeleccionat.DataAlta
            TextBoxMotiuBaixa.Text = usuariSeleccionat.MotiuBaixa
            TextBoxNomUser.Text = usuariSeleccionat.NomUsuari
            LabelPerfil.Text = usuariSeleccionat.Perfil
            If usuariSeleccionat.Estat = 0 Then 'inactiu
                CheckBoxActiu.Visible = True 'mostrem l'opció d'activar-lo
            End If
        Next

        ButtonModifica.Visible = True
        TextBoxId.Enabled = False
        TextBoxId.BackColor = Drawing.Color.LightGray

    End Sub


    ''' <summary>
    ''' Comprova la compatibilitat de les dades d'un nou usuari
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxNom.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Nom, vbInformation)
            resultat = 1
        End If
        If TextBoxCognoms.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_CogNom, vbInformation)
            resultat = 1
        End If
        If TextBoxAdreca.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Adreca, vbInformation)
            resultat = 1
        End If
        If TextBoxTelefon.Text = "" Or Len(TextBoxTelefon.Text) > 9 Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Tel, vbInformation)
            resultat = 1
        End If
        If TextBoxEmail.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaAltaUsuari_ComprovaDades_Email, vbInformation)
            resultat = 1
        End If


        Return resultat

    End Function

    ''' <summary>
    ''' Actualitza les dades modificades del usuari
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ModificaUsuari()
        'preparem el missatge de comprovació
        Dim checkAlta As String = "Comprovem dades modificades usuari " & TextBoxId.Text & vbCrLf _
                                 & "Nom :" & TextBoxNom.Text & vbCrLf _
                                 & "Cognoms :" & TextBoxCognoms.Text & vbCrLf _
                                 & "Adreça :" & TextBoxAdreca.Text & vbCrLf _
                                 & "Telèfon :" & TextBoxTelefon.Text & vbCrLf _
                                 & "Email :" & TextBoxEmail.Text & vbCrLf _
                                 & "Data alta :" & LabelDataAlta.Text & vbCrLf _
                                 & "Perfil :" & LabelPerfil.Text & vbCrLf & vbCrLf _
                                 & "Són correctes les modificacions? "

        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel Or MsgBoxStyle.Information
        Dim resposta As MsgBoxResult

        'generem el missatge de comprovació
        resposta = MsgBox(checkAlta, style)

        'si es ok endavant
        If resposta = MsgBoxResult.Ok Then
            Try
                Dim estat As Integer = 0
                If CheckBoxActiu.Checked Then estat = 1
                Dim resultat As Integer = gestor.ModificaUsuari(TextBoxId.Text, TextBoxNom.Text, TextBoxCognoms.Text, TextBoxAdreca.Text, TextBoxTelefon.Text, _
                                 TextBoxEmail.Text, LabelDataAlta.Text, LabelPerfil.Text, TextBoxNomUser.Text, estat)


                CheckBoxActiu.Visible = False 'ocultem l'opció d'activació
                If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaModificaUsuari_ModificaUsuari_OK, LabelInfo, Timer1)
                CarregaResultatCerca()
            Catch ex As Exception
                MsgBox(Resources.Missatges.Info_PaginaModificaUsuari_ModificaUsuari_KO & ex.Message)
            End Try
        Else ' si no es correcte cancelem la modificació
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaAltaUsuari_NouPerfil_CancelatPerUser, LabelInfo, Timer1)
        End If
        ButtonModifica.Visible = False
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaLlistaPerfils()
        End If

    End Sub

    

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub DropDownListPerfils_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownListPerfils.SelectedIndexChanged
        LabelPerfil.Text = DropDownListPerfils.Text 'mostrem el perfil seleccionat
    End Sub
    Protected Sub ButtonCercaCamp_Click(sender As Object, e As EventArgs) Handles ButtonCercaCamp.Click
        CarregaResultatCerca()
    End Sub

    Protected Sub ButtonNovaCerca_Click(sender As Object, e As EventArgs) Handles ButtonNovaCerca.Click
        TextBoxId.Enabled = True
        TextBoxId.BackColor = Drawing.Color.White
        ButtonModifica.Visible = False
        CheckBoxActiu.Visible = False 'ocultem l'opció d'activació
        TextBoxId.Focus()
    End Sub

    Protected Sub ButtonModifica_Click(sender As Object, e As EventArgs) Handles ButtonModifica.Click
        If ComprovaDades() = 0 Then ModificaUsuari()
    End Sub


    Protected Sub GridViewResultatCerca_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewResultatCerca.SelectedIndexChanged
        SeleccionaUsuari()
    End Sub
End Class