﻿Public Class NouMissatge
    Inherits System.Web.UI.Page

    Dim gestorMissatges As GestorBustiaBD = New GestorBustiaBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()
    Dim queryMissatge As System.Data.Linq.ISingleResult(Of RecuperaMissatgeResult)
    Dim resposta As MsgBoxResult

    ''' <summary>
    ''' Carrega els destinataris vàlids 
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaDestinataris()
        Try
            For Each destinatari In gestorUsuaris.RetornallistaUsuaris()
                If destinatari.Estat = 1 Then
                    Dim item As ListItem = New ListItem()
                    item.Text = destinatari.Cognoms
                    item.Value = destinatari.Id
                    DropDownList1.Items.Add(item)

                End If
            Next
        Catch ex As Exception

        End Try
    End Sub


    ''' <summary>
    ''' Valida el missatge abans d'enviar-lo
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function ValidarMissatge() As Boolean
        Dim ok As Boolean = True
        If LabelPer.Text = "" Then
            LabelError.Text = "No hi ha destinatari"
            ok = False
        End If
        If LabelPer.Text = "Usuari Inactiu" Then
            LabelError.Text = "No es pot enviar missatges a un usuari inactiu"
            ok = False
        End If
        If TextBoxAssumpte.Text = "" Then
            resposta = MsgBox("El assumpte ès buit. Voleu enviar el missatge?", vbYesNo)
            If resposta = vbNo Then ok = False
        End If
        Return ok
    End Function


    ''' <summary>
    ''' Executa les tasques d'enviar el missatge
    ''' </summary>
    ''' <remarks></remarks>
    Sub EnviarMissatge()
        Try

            If Utils.esReposta = True Then
                gestorMissatges.ResponMissatge(LabelDe.Text, Session("missatgeSeleccionat"))
                Utils.esReposta = False
            End If

            'creem un missatge nou
            gestorMissatges.NouMissatge(LabelDe.Text, LabelPer.Text, TextBoxAssumpte.Text, TextBoxCos.Text)
        Catch ex As Exception

        End Try
        Response.Redirect("~/Pagines/IniciBustia.aspx")
    End Sub

    ''' <summary>
    ''' Executa les tasques de respondre un missatge
    ''' </summary>
    ''' <remarks></remarks>
    Sub RespostaMissatge()
        queryMissatge = gestorMissatges.RecuperaMissatge(Session("missatgeSeleccionat"))
        For Each missatge In queryMissatge
            'recuperem les dades del missatge
            If gestorUsuaris.esActiu(missatge.Remitent) = False Then
                LabelPer.Text = "Usuari Inactiu"
            Else
                LabelPer.Text = missatge.Remitent
                LabelNomPer.Text = gestorUsuaris.ObteNomiCognomsUsuari(missatge.Remitent)
            End If



            TextBoxAssumpte.Text = "Re: " & missatge.Assumpte
            TextBoxCos.Text = vbCrLf & vbCrLf &
                            "_________________________________________________________________________________________________________" &
                            vbCrLf & vbCrLf &
                            "De: " & gestorUsuaris.ObteNomiCognomsUsuari(missatge.Remitent) & vbCrLf &
                            "Per a :" & gestorUsuaris.ObteNomiCognomsUsuari(missatge.Destinatari) & vbCrLf &
                            "Enviat: " & gestorMissatges.ObteDataEnviat(missatge.Id, UsuariActiu.idUsuari) & vbCrLf &
                            "Assumpte: " & missatge.Assumpte & vbCrLf & vbCrLf & missatge.Cos

            TextBoxAssumpte.Focus()
            TextBoxCos.Focus()
            Utils.esReposta = True
        Next


    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            'llegim el id del usuari actiu
            CarregaDestinataris()
            LabelDe.Text = UsuariActiu.idUsuari
            If Session("Resposta") = "SI" Then
                RespostaMissatge()
                Session("Resposta") = "NO"

            End If
        End If
       

    End Sub

    Protected Sub DropDownList1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownList1.SelectedIndexChanged
        LabelPer.Text = DropDownList1.SelectedItem.Value
        LabelNomPer.Text = DropDownList1.SelectedItem.Text
        LabelError.Text = ""
    End Sub

    Protected Sub Button1_Click(sender As Object, e As EventArgs) Handles ButtonEnvia.Click

        If validarMissatge() Then enviarMissatge()
    End Sub

   
End Class