﻿Public Class RealitzarTest
    Inherits System.Web.UI.Page
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()

    ''' <summary>
    ''' Carrega les preguntes i respostes del test
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaTest()
        Try
            ' Dibuixem la llista de preguntes del test
            For Each llistaPreguntes In gestorCursos.RetornaLlistaPreguntesTest(Session("idTest"))

                Dim label As Label = New Label()
                label.Text = llistaPreguntes.Text
                label.Font.Bold = True
                label.ForeColor = Drawing.Color.DarkBlue
                PlaceHolderContingut.Controls.Add(label)
                Dim espai As LiteralControl = New LiteralControl("<br /><br />")
                PlaceHolderContingut.Controls.Add(espai)


                'dibuixem la llista de respostes de la pregunta 
                For Each resposta In gestorCursos.RetornaLlistaRespostesPregunta(llistaPreguntes.Pregunta)

                    Dim respostes As New RadioButton()
                    respostes.Text = resposta.Text
                    respostes.ID = resposta.Resposta
                    respostes.GroupName = llistaPreguntes.Text
                    PlaceHolderContingut.Controls.Add(respostes)
                    Dim espai2 As LiteralControl = New LiteralControl("<br /><br />")
                    PlaceHolderContingut.Controls.Add(espai2)

                Next
                Dim espai3 As LiteralControl = New LiteralControl("<br /><br /><br />")
                PlaceHolderContingut.Controls.Add(espai3)
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaRealitzarTest_CarregaTest & ex.Message, vbExclamation)
        End Try
       
    End Sub

    ''' <summary>
    ''' Enregistre els resultats del test en funció de les respostes escollides
    ''' </summary>
    ''' <remarks></remarks>
    Sub EnregistrarTest()

        Dim idResultatTest As Integer
        Dim puntuacioTest As Double

        Try
            'obtenim el id del ResultatTest que crearem

            For Each registreId In gestorCursos.retornaUltimIdResultatTest()
                idResultatTest = registreId.Column1 + 1
            Next

            'Creem la llista de respostes del resultat del test :
            'primer recuperem les respostes seleccionades del test
            For Each ct In PlaceHolderContingut.Controls
                If ct.GetType().Name.Contains("RadioButton") Then 'si el control es un CheckBox...

                    Dim ck As RadioButton = DirectCast(ct, RadioButton) 'fem el cast
                    'marquem les respostes correctes
                    For Each resposta In gestorCursos.RetornaRespostaId(ck.ID)
                        If resposta.Correcte = 1 Then 'la resposta es correcte
                            ck.Text = "RESPOSTA CORRECTE  >>> " & ck.Text
                            ck.ForeColor = Drawing.Color.Green

                        End If
                    Next


                    'comprovem les respostes escollides
                    If ck.Checked = True Then 'resposta escollida
                        Dim puntsResposta As Double

                        'comprovem si la resposta es correcte o incorrecte i assignem els punts que l'hi pertoquen:
                        For Each regResposta In gestorCursos.RetornaRespostaId(ck.ID)
                            ck.BorderStyle = BorderStyle.Ridge
                            If regResposta.Correcte = 1 Then 'resposta correcte
                                puntsResposta = gestorCursos.ValorRespostaCorrecte(regResposta.Id)
                                ck.ForeColor = Drawing.Color.Green 'marquem com encertada
                                ck.BorderColor = Drawing.Color.Green
                            Else
                                puntsResposta = gestorCursos.ValorRespostaIncorrecte(regResposta.Id)
                                ck.ForeColor = Drawing.Color.Red  'marquem com errada
                                ck.BorderColor = Drawing.Color.Red
                            End If


                        Next

                        'creem la nova resposta escollida amb les dades recollides
                        gestorCursos.AfegirRespostaEscollida(idResultatTest, ck.ID, puntsResposta)
                        'acumulen el valos de les respostes 
                        puntuacioTest = puntuacioTest + puntsResposta
                        'reiniciem els punts de la seguent resposta
                        puntsResposta = 0.0
                    End If
                End If
            Next

            'un cop tenim la llista de respostes , creem un nou ResultatTest
            gestorCursos.AfegirResultatTest(Session("idTest"), Session("idCurs"), UsuariActiu.idUsuari, Today, puntuacioTest)
            LabelTest.Text = "Resultat del test " & Session("idTest") & ":" & puntuacioTest & " punts obtesos."
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaRealitzarTest_EnregistrarTest & ex.Message, vbExclamation)
        End Try
        
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        CarregaTest()
        LabelTest.Text = "Carregat el test " & Session("idTest")

    End Sub

   
    Protected Sub ButtonEnviar_Click(sender As Object, e As EventArgs) Handles ButtonEnviar.Click
        EnregistrarTest()
        ButtonEnviar.Visible = False
    End Sub
End Class