﻿Public Class Rebuts
    Inherits System.Web.UI.Page
    Dim gestorMissatges As GestorBustiaBD = New GestorBustiaBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()

    ''' <summary>
    ''' Carrega els missatges rebuts
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaRebuts()
        Try
            'demanem la llista de missatges rebuts del usuari
            GridViewRebuts.DataSource = gestorMissatges.RecuperaMissatgesRebuts(UsuariActiu.idUsuari)
            GridViewRebuts.DataBind()
            'Si el missatge es nou, el ressaltem
            For Each missatge As GridViewRow In GridViewRebuts.Rows
                If Len(missatge.Cells(5).Text) > 20 Then missatge.Cells(5).Text = Left(missatge.Cells(5).Text, 15) & "..."
                If missatge.Cells(6).Text.Contains(1) Then
                    missatge.Font.Bold = True
                    missatge.BackColor = Drawing.Color.LightGreen
                End If
                'convertim id a nom i cognoms
                missatge.Cells(2).Text = gestorUsuaris.ObteNomiCognomsUsuari(missatge.Cells(2).Text)
                missatge.Cells(3).Text = gestorUsuaris.ObteNomiCognomsUsuari(missatge.Cells(3).Text)
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaRebuts_CarregaRebuts & ex.Message, vbExclamation)
        End Try
        
    End Sub

    ''' <summary>
    ''' Llegeix el missatge seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub LlegeixMissatge()
        Dim seleccionat As GridViewRow
        seleccionat = GridViewRebuts.SelectedRow
        Session("missatgeSeleccionat") = seleccionat.Cells(1).Text
        Response.Redirect("~/Pagines/VistaMissatge.aspx")
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        CarregaRebuts()

    End Sub

    Protected Sub GridViewRebuts_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewRebuts.SelectedIndexChanged
        LlegeixMissatge()

    End Sub
    Protected Sub GridViewRebuts_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewRebuts.PageIndexChanging
        GridViewRebuts.PageIndex = e.NewPageIndex
        CarregaRebuts()
    End Sub

   
End Class