﻿Public Class RecursosCurs
    Inherits System.Web.UI.Page
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()


    ''' <summary>
    ''' Comprova la compatibilitat de les dades del nou recurs
    ''' </summary>
    ''' <returns>0 si correcte , 1 altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaDades() As Integer
        Dim resultat As Integer = 0

        If TextBoxNomNou.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaContingutCurs_ComprovaDades_Nom, vbInformation)
            resultat = 1
        End If
        If TextBoxTipusNou.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaContingutCurs_ComprovaDades_Tipus, vbInformation)
            resultat = 1
        End If
        If TextBoxIdCurs.Text = "" Then
            MsgBox(Resources.Missatges.Error_PaginaContingutCurs_ComprovaDades_SeleccionaCurs, vbInformation)
            resultat = 1
        End If

        Return resultat

    End Function

    ''' <summary>
    ''' Carrega la llista de cursos assignats a un tutor
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaCursosTutor()
        Try
            GridViewCursos.DataSource = gestorCursos.RetornaLlistaCursosTutor(UsuariActiu.idUsuari)
            GridViewCursos.DataBind()
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaAlumnesCurs_CarregaCursosTutor & ex.Message, vbExclamation)

        End Try
    End Sub

    ''' <summary>
    '''  Carrega les dades del curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaCurs()
        Dim selectRow As GridViewRow = GridViewCursos.SelectedRow
        Try
            For Each curs In gestorCursos.RetornaCurs(selectRow.Cells(1).Text)
                TextBoxIdCurs.Text = curs.Id
                TextBoxNomCurs.Text = curs.Nom

            Next

            CarregaLlistaRecursosCurs()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_ContingutCurs_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    '''  Carrega les dades del recurs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaRecurs()
        Dim selectRow As GridViewRow = GridViewRecursos.SelectedRow
        Try
            For Each recurs In gestorCursos.RetornaRecurs(selectRow.Cells(1).Text)
                TextBoxIdContingut.Text = recurs.Id
                TextBoxDescNou.Text = recurs.Descripcio
                TextBoxNomNou.Text = recurs.Nom
                TextBoxTipusNou.Text = recurs.Tipus

            Next

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_ContingutCurs_CarregaResultatCerca & ex.Message)
        End Try

    End Sub

    ''' <summary>
    ''' Carrega la llista dels recursos assignats al curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaLlistaRecursosCurs()
        Try
            Dim index As Integer = 1

            GridViewLlistaRecursos.DataSource = gestorCursos.RetornaLlistaRecursosCurs(TextBoxIdCurs.Text)
            GridViewLlistaRecursos.DataBind()
            GridViewLlistaRecursos.Caption = "Llista recursos del curs " & TextBoxIdCurs.Text


        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaRecursosCurs_CarregaLlistaRecursosCurs & ex.Message, vbExclamation)

        End Try
    End Sub

   
    ''' <summary>
    ''' Retorna els recursos cercats
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaResultatCercaRecursos()
        Try
            If DropDownListCerca.Text = "Id" Then
                GridViewRecursos.DataSource = gestorCursos.RetornaRecurs(TextBoxIdContingut.Text)
            ElseIf DropDownListCerca.Text = "Nom" Then
                GridViewRecursos.DataSource = gestorCursos.RetornaRecursNom(TextBoxNomNou.Text)
            End If

            GridViewRecursos.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaRecursosCurs_CarregaLlistaRecursosCurs & ex.Message)
        End Try

    End Sub


    ''' <summary>
    ''' Neteja les dades mostrades
    ''' </summary>
    ''' <remarks></remarks>
    Sub NetejaPantalla()
        TextBoxDescNou.Text = ""
        TextBoxNomNou.Text = ""
        TextBoxDescNou.Text = ""

    End Sub

    ''' <summary>
    '''  Assigna un nou element a la llista
    ''' </summary>
    ''' <remarks></remarks>
    Sub Assigna()

        Try
            Dim resultat As Integer = gestorCursos.AssignaRecurs(TextBoxIdContingut.Text, TextBoxIdCurs.Text)

            If resultat = 0 Then Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaContingutCurs_Assigna_OK, LabelInfo, Timer1)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Info_PaginaContingutCurs_Assigna_KO & ex.Message)
        End Try
        CarregaLlistaRecursosCurs()
    End Sub



    ''' <summary>
    ''' Desassigna un element  de la llista
    ''' </summary>
    ''' <remarks></remarks>
    ''' 
    Sub Desassigna()
        Try
            gestorCursos.EliminaAssignacioRecurs(TextBoxIdContingut.Text, TextBoxIdCurs.Text)
            CarregaLlistaRecursosCurs()
            NetejaPantalla()
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaContingutCurs_DesAssigna_OK, LabelInfo, Timer1)

        Catch ex As Exception
            Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaContingutCurs_DesAssigna_OK, LabelInfo, Timer1)

        End Try

    End Sub



    Protected Sub GridViewCursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewCursos.SelectedIndexChanged
        SeleccionaCurs()
    End Sub
    Protected Sub GridViewCursos_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewCursos.PageIndexChanging
        GridViewCursos.PageIndex = e.NewPageIndex
        CarregaCursosTutor()
    End Sub


    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub

    Protected Sub ButtonAfegir_Click(sender As Object, e As EventArgs) Handles ButtonAfegir.Click
        If ComprovaDades() = 0 Then Assigna()

    End Sub

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        CarregaCursosTutor()
    End Sub

    Protected Sub ButtonCerca_Click(sender As Object, e As EventArgs) Handles ButtonCerca.Click
        CarregaResultatCercaRecursos()

    End Sub

    Protected Sub GridViewRecursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewRecursos.SelectedIndexChanged
        SeleccionaRecurs()

    End Sub
    Protected Sub GridViewRecursos_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewRecursos.PageIndexChanging
        GridViewRecursos.PageIndex = e.NewPageIndex
        CarregaResultatCercaRecursos()
    End Sub

    Protected Sub ButtonEliminar_Click(sender As Object, e As EventArgs) Handles ButtonEliminar.Click
        Desassigna()
    End Sub

    Protected Sub GridViewLlistaRecursos_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewLlistaRecursos.SelectedIndexChanged

    End Sub
    Protected Sub GridViewLlistaRecursos_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewLlistaRecursos.PageIndexChanging
        GridViewLlistaRecursos.PageIndex = e.NewPageIndex
        CarregaLlistaRecursosCurs()
    End Sub
End Class