﻿Public Class VistaAlumne
    Inherits System.Web.UI.Page
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()
    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()

    ''' <summary>
    ''' Carrega les dades del alumne
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaDadesAlumne()
        Try
            LabelCurs.Text = Session("idCurs")
            LabelIdAlumne.Text = Session("idAlumne")
            LabelNomAlumne.Text = gestorUsuaris.ObteNomiCognomsUsuari(Session("idAlumne"))
        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' Carrega la llista de test realitzats per el alumne
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaTestRealitzats()
        Try
            GridViewTestRealitzats.DataSource = gestorCursos.RetornaLlistaTestRealitzatsAlumne(Session("idAlumne"))
            GridViewTestRealitzats.DataBind()
            For Each registre As GridViewRow In GridViewTestRealitzats.Rows
                Dim idTest As TableCell = New TableCell() 'afegim el id del test ocult al final 
                idTest.Text = registre.Cells(1).Text
                idTest.Visible = False

                registre.Cells.Add(idTest)
                registre.Cells(1).Text = gestorCursos.RetornaNomTest(registre.Cells(1).Text)
                registre.Cells(3).Text = gestorUsuaris.ObteNomiCognomsUsuari(registre.Cells(3).Text)
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_CarregaTestRealitzats & ex.Message, vbExclamation)
        End Try
    End Sub

    ''' <summary>
    ''' Selecciona les dades del test escollit
    ''' </summary>
    ''' <remarks></remarks>
    Sub SeleccionaTest()
        Dim selectRow As GridViewRow = GridViewTestRealitzats.SelectedRow
        Try
            LabelIdTest.Text = selectRow.Cells(6).Text
            CarregaRespostesEscollides()
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_SeleccionaTest & ex.Message, vbExclamation)

        End Try
    End Sub

    ''' <summary>
    ''' Carrega la llista de respostes escollides del test
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaRespostesEscollides()
        Try
            GridViewRespostesEscollides.DataSource = gestorCursos.RetornaLlistaRespostesEscollides(LabelIdAlumne.Text, LabelIdTest.Text)
            GridViewRespostesEscollides.DataBind()

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_CarregaRespostesEscollides & ex.Message, vbExclamation)
        End Try
    End Sub

    ''' <summary>
    ''' Obté la nota del alumne en el curs
    ''' </summary>
    ''' <remarks></remarks>
    Sub RecuperaNota()
        Try
            LabelNota.Text = gestorCursos.RetornaNotaAlumne(LabelIdAlumne.Text, LabelCurs.Text)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_RecuperaNota & ex.Message, vbExclamation)

        End Try
    End Sub

  

    ''' <summary>
    ''' Assigna la nota del curs al alumne
    ''' </summary>
    ''' <remarks></remarks>
    Sub AssignaNota()
        Try
            If gestorCursos.AssignaNota(LabelCurs.Text, LabelIdAlumne.Text, DropDownListNota.Text) = 0 Then
                Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaVistaAlumne_AssignaNota_OK, LabelInfo, Timer1)
            Else
                Utils.MostrarInformacioAccio(Resources.Missatges.Info_PaginaVistaAlumne_AssignaNota_KO, LabelInfo, Timer1)

            End If
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaAlumne_AssignaNota & ex.Message, vbExclamation)

        End Try
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        CarregaDadesAlumne()
        CarregaTestRealitzats()
        RecuperaNota()

    End Sub

    Protected Sub GridViewTestRealitzats_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewTestRealitzats.SelectedIndexChanged
        SeleccionaTest()
    End Sub
    Protected Sub GridViewTestRealitzats_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewTestRealitzats.PageIndexChanging
        GridViewTestRealitzats.PageIndex = e.NewPageIndex
        CarregaTestRealitzats()
    End Sub

    Protected Sub ButtonAssigna_Click(sender As Object, e As EventArgs) Handles ButtonAssigna.Click
        AssignaNota()
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabelInfo.Visible = False
        Timer1.Enabled = False

    End Sub
End Class