﻿Public Class VistaCalendari
    Inherits System.Web.UI.Page
    Dim gestor As GestorCalendariBD = New GestorCalendariBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()


    ''' <summary>
    '''  Redirecciona a la pàgina d'inici del perfil del usuari
    ''' </summary>
    ''' <remarks></remarks>
    Sub IniciUsuari()
        Dim desti As String = ""

        If UsuariActiu.perfilUsuari.Contains("Administrador") Then
            desti = "~/Pagines/IniciAdmin.aspx"
        ElseIf UsuariActiu.perfilUsuari.Contains("Tutor") Then
            desti = "~/Pagines/IniciTutor.aspx"
        ElseIf UsuariActiu.perfilUsuari.Contains("Alumne") Then
            desti = "~/Pagines/IniciAlumne.aspx"
        End If

        Response.Redirect(desti)
    End Sub

    ''' <summary>
    ''' Carrega la llista d'events del mes actual,dels cursos associats al usuari actiu
    ''' </summary>
    ''' <param name="data"></param>
    ''' <remarks></remarks>
    Sub CarregarGrid(ByVal data As Date)

        GridViewCalendari.DataSource = gestor.RetornaLlistaEventsMes(UsuariActiu.idUsuari, data)
        GridViewCalendari.DataBind()
        'Controlem la vista prèvia
        For Each missatge As GridViewRow In GridViewCalendari.Rows
            'convertim id a nom i cognoms
            missatge.Cells(3).Text = gestorUsuaris.ObteNomiCognomsUsuari(missatge.Cells(3).Text)
        Next
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then CarregarGrid(Today)
    End Sub

    Private Sub Calendar1_DayRender(sender As Object, e As System.Web.UI.WebControls.DayRenderEventArgs) Handles Calendar1.DayRender

        'Carreguem al calendari la llista d'events dels cursos del usuari
        For Each reg In gestor.RetornaLlistaEventsUsuari(UsuariActiu.idUsuari)
            If e.Day.Date = reg.Data Then
                e.Cell.Text = e.Cell.Text & e.Day.Date.Day & vbCrLf & reg.Descripcio
                e.Cell.BackColor = Drawing.Color.Chartreuse
            End If
        Next


    End Sub

    Protected Sub Calendar1_SelectionChanged(sender As Object, e As EventArgs) Handles Calendar1.SelectionChanged

    End Sub

    Public Sub Calendar1_VisibleMonthChanged(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MonthChangedEventArgs) Handles Calendar1.VisibleMonthChanged
        'responem al event de canviar el mes 
        CarregarGrid(e.NewDate)
    End Sub

    Protected Sub Menu1_MenuItemClick(sender As Object, e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
        IniciUsuari()
    End Sub

    Protected Sub GridViewCalendari_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewCalendari.SelectedIndexChanged

    End Sub
    Protected Sub GridViewCalendari_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewCalendari.PageIndexChanging
        GridViewCalendari.PageIndex = e.NewPageIndex
        CarregarGrid(Calendar1.SelectedDate)
    End Sub
End Class