﻿Public Class VistaCurs
    Inherits System.Web.UI.Page

    Dim gestorCursos As GestorCursosBD = New GestorCursosBD()
    Dim gestorUsuaris As GestorUsuarisBD = New GestorUsuarisBD()
    Dim cursPredet As String

    ''' <summary>
    ''' Comprova si l'alumne ha realitzat el test
    ''' </summary>
    ''' <returns>true si realitzat, false altrament</returns>
    ''' <remarks></remarks>
    Function ComprovaTestRealitzat() As Boolean
        Dim resultat As Boolean = False
        Try
            Return gestorCursos.ComprovaTestRealitzat(MenuTest.SelectedValue, UsuariActiu.idUsuari)
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_GestorCursosBD_ComprovaTestRealitzat & ex.Message, vbExclamation)
        End Try
        Return resultat


    End Function

    ''' <summary>
    ''' Carrega la llista de cursos del alumne
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaCursosAlumne()
        Try
            Dim i As Integer = 1
            For Each Curs In gestorCursos.RetornaLlistaCursosAlumne(UsuariActiu.idUsuari)
                DropDownListCursos.Items.Add(Curs.Id)
                If i = 1 Then cursPredet = Curs.Id
                i = i + 1
            Next
        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaCurs_CarregaCursosAlumne & ex.Message, vbExclamation)

        End Try
    End Sub

    ''' <summary>
    ''' Carrega els continguts,recursos i test del curs seleccionat
    ''' </summary>
    ''' <remarks></remarks>
    Sub CarregaContingutCurs(ByVal idCurs As String)
        Try
            'mostrem al tutor del curs
            For Each cursCercat In gestorCursos.RetornaCurs(idCurs)
                LabelTutor.Text = gestorUsuaris.ObteNomiCognomsUsuari(cursCercat.TutorPrincipal)
            Next

            'carreguem els continguts del curs

            'buidem contingut anterior
            MenuContinguts.Items.Clear()
            MenuRecursos.Items.Clear()
            MenuTest.Items.Clear()

            For Each contingut In gestorCursos.RetornaLlistaContingutsCurs(idCurs)
                Dim elementMenu As MenuItem = New MenuItem()
                elementMenu.Text = contingut.Nom
                elementMenu.NavigateUrl = contingut.Ruta
                elementMenu.Target = "_blank" 'obre el recurs en una finestra nova
                MenuContinguts.Items.Add(elementMenu)
            Next
            'carreguem els recursos del curs
            For Each recurs In gestorCursos.RetornaLlistaRecursosCurs(idCurs)
                Dim elementMenu As MenuItem = New MenuItem()
                elementMenu.Text = recurs.Nom
                elementMenu.NavigateUrl = recurs.Ruta
                elementMenu.Target = "_blank" 'obre el recurs en una finestra nova
                MenuRecursos.Items.Add(elementMenu)
            Next
            'carreguem els test del curs
            For Each test In gestorCursos.RetornaLlistaTestCurs(idCurs)
                Dim elementMenu As MenuItem = New MenuItem()
                elementMenu.Text = test.Nom
                elementMenu.Value = test.IdTest
                MenuTest.Items.Add(elementMenu)
            Next
            GridViewTestRealitzats.DataSource = gestorCursos.RetornaLlistaTestRealitzatsAlumne(UsuariActiu.idUsuari)
            GridViewTestRealitzats.DataBind()
            For Each registre As GridViewRow In GridViewTestRealitzats.Rows
                registre.Cells(0).Text = gestorCursos.RetornaNomTest(registre.Cells(0).Text)
                registre.Cells(2).Text = gestorUsuaris.ObteNomiCognomsUsuari(registre.Cells(2).Text)
            Next

        Catch ex As Exception
            MsgBox(Resources.Missatges.Error_PaginaVistaCurs_CarregaContingutCurs & ex.Message, vbExclamation)

        End Try

    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            CarregaCursosAlumne()
            CarregaContingutCurs(cursPredet)
        End If


    End Sub

    Protected Sub DropDownList1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownListCursos.SelectedIndexChanged
        CarregaContingutCurs(DropDownListCursos.SelectedValue)
    End Sub

    Protected Sub MenuTest_MenuItemClick(sender As Object, e As System.Web.UI.WebControls.MenuEventArgs) Handles MenuTest.MenuItemClick
        Session("idTest") = MenuTest.SelectedValue
        Session("idCurs") = DropDownListCursos.Text
        If ComprovaTestRealitzat() = True Then
            MsgBox(Resources.Missatges.Info_PaginaVistaCurs_TestRealitzat, vbInformation)
        Else
            Response.Redirect("~/Pagines/RealitzarTest.aspx")
        End If

    End Sub

    Protected Sub GridViewTestRealitzats_SelectedIndexChanged(sender As Object, e As EventArgs) Handles GridViewTestRealitzats.SelectedIndexChanged

    End Sub
    Protected Sub GridViewTestRealitzats_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs) Handles GridViewTestRealitzats.PageIndexChanging
        GridViewTestRealitzats.PageIndex = e.NewPageIndex
        CarregaContingutCurs(cursPredet)
    End Sub
End Class